#include "Common.ch"
#include "Gra.ch"
#include "Xbp.ch"
#include "Appevent.ch"
#include "Font.ch"
#include "Dll.ch"
#INCLUDE "dcdialog.CH"

#ifndef xbeM_Enter
  #define xbeM_Enter  (005 + xbeB_Event)
#endif

#ifndef xbeM_Leave
  #define xbeM_Leave  (006 + xbeB_Event)
#endif

#ifndef xbeP_PresParamChanged
  #define xbeP_PresParamChanged          (051 + xbeB_Event)
#endif

#ifndef xbeP_MeasureItem
  #define xbeP_MeasureItem               (072 + xbeB_Event)
  #define xbeP_DrawItem                  (073 + xbeB_Event)
  #define xbeP_DragEnter                 (074 + xbeB_Event)
  #define xbeP_DragMotion                (075 + xbeB_Event)
  #define xbeP_DragLeave                 (076 + xbeB_Event)
  #define xbeP_DragDrop                  (077 + xbeB_Event)
#endif

#ifndef XBP_DRAW_OWNER
// Drawing modes used with XBPs
#define XBP_DRAW_NORMAL                0
#define XBP_DRAW_OWNER                 1
#define XBP_DRAW_OWNERADVANCED         2

// Drawing actions for XBPs rendered using drawing
// modes XBP_DRAW_OWNER or XBP_DRAW_OWNER_ADVANCED
#define XBP_DRAWACTION_DRAWALL         1
#define XBP_DRAWACTION_SELCHANGE       2
#define XBP_DRAWACTION_FOCUSCHANGE     4

// Drawing status used with XBPs rendered using drawing
// modes XBP_DRAW_OWNER or XBP_DRAW_OWNER_ADVANCED
#define XBP_DRAWSTATE_SELECTED         1
#define XBP_DRAWSTATE_GRAYED           2
#define XBP_DRAWSTATE_DISABLED         4
#define XBP_DRAWSTATE_CHECKED          8
#define XBP_DRAWSTATE_FOCUS            16
#define XBP_DRAWSTATE_DEFAULTITEM      32
#define XBP_DRAWSTATE_COMBOBOXEDIT     4096
#endif

#DEFINE SND_SYNC      0   // 0x0000   // (Default flag) Plays sound synchronously, all the way through.
#DEFINE SND_ASYNC     1   // 0x0001   // Plays sound asynchronously.
#DEFINE SND_LOOP      8   // 0x0008   // Continues playing the sound until the function is called again.
#DEFINE SND_NOSTOP    10  // 0x00010  // Doesn't stop the current sound.
#DEFINE SND_FILENAME  131072
#define SND_PURGE 64

#define COLOR_RED           GraMakeRGBColor( { 255,   0,   0 } )
#define COLOR_DARKRED       GraMakeRGBColor( { 127,   0,   0 } )
#define COLOR_GREEN         GraMakeRGBColor( {   0, 255,   0 } )
#define COLOR_DARKGREEN     GraMakeRGBColor( {   0, 127,   0 } )
#define COLOR_BLUE          GraMakeRGBColor( {   0,   0, 255 } )
#define COLOR_DARKBLUE      GraMakeRGBColor( {   0,   0, 127 } )
#define COLOR_CYAN          GraMakeRGBColor( {   0, 255, 255 } )
#define COLOR_DARKCYAN      GraMakeRGBColor( {   0, 127, 127 } )
#define COLOR_YELLOW        GraMakeRGBColor( { 255, 255,   0 } )
#define COLOR_BROWN         GraMakeRGBColor( { 127, 127,   0 } )
#define COLOR_PINK          GraMakeRGBColor( { 255,   0, 255 } )
#define COLOR_DARKPINK      GraMakeRGBColor( { 127,   0, 127 } )
#define COLOR_WHITE         GraMakeRGBColor( { 255, 255, 255 } )
#define COLOR_BLACK         GraMakeRGBColor( {   0,   0,   0 } )
#define COLOR_PALEGRAY      GraMakeRGBColor( { 192, 192, 192 } )
#define COLOR_DARKGRAY      GraMakeRGBColor( { 127, 127, 127 } )
#define COLOR_ORANGE        GraMakeRGBColor( { 253, 120,  41 } )
#define COLOR_LTORANGE      GraMakeRGBColor( { 250, 205,   0 } )
#define COLOR_LTBLUE        GraMakeRGBColor( {  30, 187, 255 } )
#define COLOR_LTYELLOW      GraMakeRGBColor( { 244, 244, 210 } )
#define COLOR_LTGRAY        GraMakeRGBColor( { 220, 220, 220 } )
#define COLOR_DARKERGRAY    GraMakeRGBColor( {  84,  84,  84 } )
#define COLOR_DISABLED      GraMakeRGBColor( { 220, 220, 220 } )
#define COLOR_DISABLEDTEXT  GraMakeRGBColor( { 150, 150, 150 } )

#if XPPVER > 1900000

* ------------------

CLASS DC_XbpPushButtonXP FROM DC_XbpPushButtonXPSuper, DC_XbaseParts

EXPORTED:
VAR focusRectStyle
VAR focusRectColor
VAR radius
VAR outline
VAR color
VAR fgColor
VAR bgColor
VAR fgColorClick
VAR bgColorClick
VAR fgColorSelected
VAR bgColorSelected
VAR bgColorMouse
VAR fgColorMouse
VAR alignCaption
VAR alignBitmap
VAR bitmap
VAR bitmapSource
VAR font
VAR fontObject
VAR captionArray
VAR mouseMode
VAR gradient
VAR gradientReverse
VAR gradientStep
VAR gradientStyle
VAR gradientBlock				// abo service
VAR toolBar
VAR toolBarCreated
VAR actionBlock
VAR menuBlock
VAR menuButtonFont
VAR menuClicked
VAR captionOffset
VAR bitmapOffset
VAR bitmapScale
VAR activated
VAR nShortCut
VAR menuButtonWidth
VAR config
VAR convertLegacy
VAR oldShortCut
VAR tileBitmap
VAR tileBitmapSource
VAR saveSize
VAR savePos
VAR saveFont
VAR saveParent
VAR mouseOverScale
VAR mouseOverSound
VAR mouseOverFont
VAR mouseOverFontObject
VAR disabledBGColor
VAR selected
VAR enableSelect
VAR disabledFGColor      // abo service
VAR disabledbmp          // abo service
VAR isCodeBlockCaption
VAR isCodeBlockFont
VAR isCodeBlockBitmap
VAR isPopup
VAR borderColor
VAR setNormalFont
VAR isStatic
VAR animate
VAR shadowType          // abo service
VAR gradientLevel       // abo service
VAR captionResType
VAR captionResFile
VAR isTransparent
VAR isTextShadow
VAR textShadowColor
VAR textShadowOffset
VAR isBitmapBackground
VAR isResizing

METHOD Init, Create, Action, GetShortCut, SetShortCut, Destroy, ;
       WhenHideEval, Draw, SetFontName, SetCaption, ;
       SetCaptionStr, SetBitMap, SetCaptionArray, ConfigureCaptionArray, ;
       SetBitMapTile, MouseEnter, MouseLeave, RefreshCaptionArray, ;
       SetFontNameMouseOver, lbclick, Refresh, Resize

ENDCLASS

* ------------------

METHOD DC_XbpPushButtonXP:Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList, oConfig, lPopUp )

LOCAL xOptions, bBlock, cCaption, aGetList, aGetListItem, aGetOptions

::xbpPushButton:Init( oParent, oOwner, aPos, aSize, aPres, lVisible )

::DC_XbaseParts:init( oGetList,,self )
aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions

::drawMode := XBP_DRAW_OWNER
::mouseMode := 0
::captionArray := {}
::activated := .f.
::menuClicked := .f.
::selected := .f.
::enableSelect := .f.
::disabledbmp := .t.     // ABO service
::isCodeBlockCaption := .f.
::isCodeBlockFont := .f.
::isCodeBlockBitmap := .f.
::setNormalFont := .f.
::isStatic := .f.
::isResizing := .f.
::gradientLevel := 100
//::useVisualStyle := .t.

::LbDblClick := {|aPos,uNil,o| o:HandleEvent(xbeM_LbDown,aPos,NIL)}

::isPopUp := IIF(Valtype(lPopUp) == 'L', lPopUp, .f.)
IF Valtype(oConfig) == 'O'
  ::convertLegacy := .t.
  ::config := oConfig
  ::borderColor := ::config:borderColor   // abo service
ELSE
  ::convertLegacy := .f.
ENDIF

::activate := {|a,b,o|::Action(a,b,o)}

::keyboard := { |a,b,o|IIF(a=xbeK_ENTER,Eval(o:activate,a,b,o,::getList:getListArray),nil) }

IF !::isPopup
  bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
  IF Valtype(bBlock) = 'B'
    Eval( bBlock, self )
  ENDIF

  bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
  IF Valtype(bBlock) = 'B' .AND. !::isPopUp
    Eval( bBlock, self )
  ENDIF
ENDIF

RETURN self

* ------------------ *

METHOD DC_XbpPushButtonXP:create( oParent, oOwner, aPos, aSize, ;
                                  aPresParam, lVisible, cCaption, cFont, oBitmap )

LOCAL aOptions, aGetList, aGetListItem, aGetOptions, nButtonStyle, xResource, ;
      i, lHide, aColor, nWidth, nSeconds := Seconds(), nColor

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions

DEFAULT oParent := ::setParent()

::xbpPushButton:create( oParent, oOwner, aPos, aSize, aPresParam, lVisible )

lHide := aGetOptions[lGETOPT_HIDEDIALOG]

IF !Empty(cCaption)
  // J. Duijf 17-07-2014 Pass aSize as parameter (in case icon)
  ::caption := DC_GetBitmap(cCaption,,,,,.t.,aSize)
ELSEIF !Empty(aGetListItem[cGETLIST_CAPTION])
  ::caption := DC_GetBitmap(aGetListItem[cGETLIST_CAPTION],,,,,.t.)
ENDIF

IF !::convertLegacy

  ::color := aGetListItem[aGETLIST_COLOR]
  IF Valtype(::color)='A'
    IF Valtype(::color[1]) = 'B'
      ::color := ::color[1]
    ELSEIF Valtype(::color[1]) = 'A'
      ::fgColor := ::color[1,1]
      ::bgColor := ::color[1,2]
    ELSE
      ::fgColor := ::color[1]
      ::bgColor := ::color[2]
    ENDIF
    IF Valtype(::fgColor) == 'A'
      ::fgColor := GraMakeRGBColor(::fgColor)
    ENDIF
    IF Valtype(::bgColor) == 'A'
      ::bgColor := GraMakeRGBColor(::bgColor)
    ENDIF
  ENDIF

  aOptions := aGetListItem[xGETLIST_OPTIONS9]

  ASize(aOptions,38)

  ::menuBlock := aOptions[1]
  ::outline := aOptions[2]
  ::captionOffset := aOptions[3]
  ::radius := aOptions[4]
  ::bitmap := DC_GetBitMap(aOptions[5],,,,,.t.)
  ::bitmapSource := aOptions[5]
  IF Valtype(::bitmapSource) == 'B'
    ::isCodeBlockBitmap := .t.
  ENDIF

  ::fgColorMouse := aOptions[6]
  IF Valtype(::fgColorMouse) == 'A'
    ::fgColorMouse := GraMakeRGBColor(::fgColorMouse)
  ENDIF

  ::bgColorMouse := aOptions[7]
  IF Valtype(::bgColorMouse) == 'A'
    ::bgColorMouse := GraMakeRGBColor(::bgColorMouse)
  ENDIF

  ::fgColorClick := aOptions[8]
  IF Valtype(::fgColorClick) == 'A'
    ::fgColorClick := GraMakeRGBColor(::fgColorClick)
  ENDIF

  ::bgColorClick := aOptions[9]
  IF Valtype(::bgColorClick) == 'A'
    ::bgColorClick := GraMakeRGBColor(::bgColorClick)
  ENDIF

  ::gradientStep := aOptions[10]
  ::gradientReverse := aOptions[11]
  ::gradientStyle := aOptions[12]
  ::captionArray := aOptions[13] ; DEFAULT ::captionArray := {}
  ::alignBitmap := aOptions[14]
  ::bitmapOffset := aOptions[15]
  ::tileBitMap := DC_GetBitmap(aOptions[16],,,,,.t.)
  ::tileBitMapSource := aOptions[16]
  ::bitmapScale := aOptions[17]
  ::mouseOverSound := aOptions[18]
  ::mouseOverScale := aOptions[19]
  ::mouseOverFont := aOptions[20]
  ::disabledBGColor := aOptions[21]
  IF Valtype(::disabledBGColor) == 'A'            // abo service
    ::disabledBGColor := GraMakeRGBColor(::disabledBGColor)    // abo service
  ENDIF                       // abo service

  ::fgColorSelected := aOptions[22]
  IF Valtype(::fgColorSelected) == 'A'
    ::fgColorSelected := GraMakeRGBColor(::fgColorSelected)
  ENDIF

  ::bgColorSelected := aOptions[23]
  IF Valtype(::bgColorSelected) == 'A'
    ::bgColorSelected := GraMakeRGBColor(::bgColorSelected)
  ENDIF

  ::enableSelect := aOptions[24]
  ::selected := aOptions[25]
  DEFAULT ::selected := .f.

  ::disabledFGColor := aOptions[26]                             // abo service
  IF Valtype(::disabledFGColor) == 'A'                          // abo service
    ::disabledFGColor := GraMakeRGBColor(::disabledFGColor)     // abo service
  ENDIF

  ::disabledBmp := aOptions[27]         // abo service
  ::borderColor := aOptions[28]         // abo service
  IF Valtype(::borderColor) == 'A'      // abo service
    ::borderColor := GraMakeRGBColor(::borderColor)  // abo service
  ENDIF                      // abo service

  ::isStatic := aOptions[29]
  ::focusRectStyle := aOptions[30]
  ::focusRectColor := aOptions[31]
  ::shadowType := aOptions[32]
  ::gradientLevel := aOptions[33]
  ::isTransparent := aOptions[34]
  ::isTextShadow := aOptions[35]
  ::textShadowColor := aOptions[36]
  ::textShadowOffset := aOptions[37]
  ::isBitmapBackground := aOptions[38]

  IF Valtype(::disabledBmp) == 'N'   // abo service   if the parameter is '1', the bmp must be shown in original color
    ::disabledBmp := ::disabledBmp # 1
  ENDIF

  IF Valtype(aGetListItem[oGETLIST_CONFIG]) == 'O'
    ::config := aGetListItem[oGETLIST_CONFIG]
  ELSEIF oParent:isDerivedFrom('DC_XbpToolBar') .AND. !Empty(oParent:buttonConfig)
    ::config := oParent:buttonConfig
  ELSE
    ::config := DC_XbpPushButtonXPDefault()
  ENDIF

ELSE

  IF Valtype(::caption) $ 'OA'
    IF Valtype(::caption) == 'A'
      ::bitmap := DC_GetBitmap(::caption[1],,,,,.t.)
    ELSE
      ::bitmap := ::caption
    ENDIF
    ::alignBitmap := XBPALIGN_VCENTER + XBPALIGN_HCENTER
    ::caption := nil
  ENDIF

  aOptions := aGetListItem[xGETLIST_OPTIONS9]

  IF Valtype(aOptions) == 'A'
    ASize(aOptions,38)
    ::menuBlock := aOptions[1]
    ::bitmapSource := aOptions[5]
    ::bitmap := DC_GetBitMap(aOptions[5],,,,,.t.)
  ENDIF

ENDIF

IF !Empty(oBitmap)
  ::bitmap := DC_GetBitmap(oBitmap)
ENDIF

IF !Empty(cFont)
  IF Valtype(cFont) == 'C'
    ::font := cFont
//  ELSEIF Valtype(cFont) == 'O'
//    ::fontObject := cFont
  ENDIF
ELSEIF !::isPopup
  ::font := aGetListItem[cGETLIST_FONT]
  IF Empty(::font) .AND. !Empty(::config:font)
    IF Valtype(::config:font) == 'C'
      ::font := ::config:font

//      ::fontObject := DC_FontConfigure( nil, ::font,,, ::getList:scaleFactor )
//    ELSEIF Valtype(::config:font) == 'O'
//      ::fontObject := ::config:font
    ENDIF
  ELSEIF Valtype(::font) == 'C'
//      ::setFont(XbpFont():new():create())
//    ::fontObject := DC_FontConfigure( nil, ::font,,, ::getList:scaleFactor )
  ENDIF
ENDIF

DEFAULT ::color := ::config:color
DEFAULT ::radius := ::config:radius
DEFAULT ::outline := ::config:outline
DEFAULT ::bgColor := ::config:bgColor
DEFAULT ::fgColor := ::config:fgColor
DEFAULT ::fgColorClick := ::config:fgColorClick
DEFAULT ::bgColorClick := ::config:bgColorClick
DEFAULT ::fgColorSelected := ::config:fgColorSelected
DEFAULT ::bgColorSelected := ::config:bgColorSelected
DEFAULT ::alignCaption := ::config:alignCaption
DEFAULT ::alignBitmap := ::config:alignBitmap
DEFAULT ::fgColorMouse := ::config:fgColorMouse
DEFAULT ::bgColorMouse := ::config:bgColorMouse
DEFAULT ::gradientReverse := ::config:gradientReverse
DEFAULT ::gradientStep := ::config:gradientStep
DEFAULT ::gradientStyle := ::config:gradientStyle
DEFAULT ::captionOffset := ::config:captionOffset
DEFAULT ::bitmapOffset := ::config:bitmapOffset
DEFAULT ::bitmapScale  := ::config:bitmapScale
DEFAULT ::menuButtonWidth := ::config:menuButtonWidth
DEFAULT ::tileBitMap := ::config:tileBitmap
DEFAULT ::mouseOverSound := ::config:mouseOverSound
DEFAULT ::mouseOverScale := ::config:mouseOverScale
DEFAULT ::mouseOverFont := ::config:mouseOverFont
DEFAULT ::disabledBGColor := ::config:disabledBGColor
DEFAULT ::fgColorSelected := ::config:fgColorSelected
DEFAULT ::bgColorSelected := ::config:bgColorSelected
DEFAULT ::disabledFGColor := ::config:disabledFGColor  // abo service
DEFAULT ::disabledBmp := ::config:disabledBmp          // abo service
DEFAULT ::BorderColor := ::config:BorderColor          // abo service
DEFAULT ::isStatic := ::config:isStatic
DEFAULT ::focusRectStyle := ::config:focusRectStyle
DEFAULT ::focusRectColor := ::config:focusRectColor
DEFAULT ::enableSelect := ::config:enableSelect
DEFAULT ::shadowType := ::config:shadowType
DEFAULT ::gradientLevel := ::config:gradientLevel
DEFAULT ::isTransparent := ::config:isTransparent
DEFAULT ::isTextShadow := ::config:isTextShadow
DEFAULT ::textShadowColor := ::config:textShadowColor
DEFAULT ::textShadowOffset := ::config:textShadowOffset
DEFAULT ::isBitmapBackground := ::config:isBitmapBackground
::gradientBlock := ::config:gradientBlock				// abo service
IF ::borderColor > 0
  ::outline := .T.
ENDIF

IF ::shadowType == nil
  ::shadowType := 0
ENDIF

IF ::bgColor == nil .OR. ::isTransparent
  ::bgColor := oParent:setColorBG()
  IF ::bgColor == nil
    ::bgColor := GraMakeRGBColor(GRA_CLR_BACKGROUND)
  ENDIF
ENDIF

/*
IF Valtype(::mouseOverFont) == 'C' .AND. !Empty(::mouseOverFont)
  ::mouseOverFontObject := DC_FontConfigure( nil, ::mouseOverFont,,, ::getList:scaleFactor )
ELSEIF Valtype(::mouseOverFont) == 'O'
  ::mouseOverFontObject := ::mouseOverFont
ENDIF
*/

IF !::isPopup
  ::actionBlock := DC_GetBlock(aGetListItem[bGETLIST_ACTION])
ENDIF

IF !Empty(::menuBlock)
  ::menuButtonWidth := 15
ENDIF

::SetShortCut()

IF Valtype(::paint) = 'B'
  ::invalidateRect()
ENDIF

::ConfigureCaptionArray(.f.)

IF !::isStatic
  ::enter := {||::mouseEnter()}
  ::leave := {||::mouseLeave()}
  ::motion := {|a,b,o|IIF(o:mouseMode=2,(::mouseMode:=1,::invalidateRect()),nil)}
ENDIF

IF !Empty(::menuBlock)
  ::menuButtonFont := XbpFont():new()
  ::menuButtonFont:nominalPointSize := 8
  ::menuButtonFont:compoundName := 'Marlett'
  ::menuButtonFont:create()
ENDIF

// ::gradientStep := Int(::gradientStep)

IF !::isPopup
  ::DC_XbaseParts:setOrig(self)

  IF Valtype(::whenBlock) = 'B' .AND. !Eval(::whenBlock,self)
    IF Valtype(aGetListItem[cGETLIST_CAPTION]) # 'A'
      ::disable()
    ENDIF
  ENDIF

  ::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

  aOptions := aGetListItem[xGETLIST_OPTIONS2]

  IF Empty(aOptions)
    aOptions := aGetOptions[aGETOPT_BUTTONSOUND]
  ENDIF
  IF !Empty(aOptions)
    ::lbDown := DC_MergeBlocks(::lbDown,_ButtonSoundBlock(aOptions,1))
    ::lbUp   := DC_MergeBlocks(::lbUp,_ButtonSoundBlock(aOptions,2))
  ENDIF
ENDIF

RETURN self

* --------------------

METHOD DC_XbpPushButtonXP:Draw( oPS, mp2, nMode )

LOCAL aAreaAttrs   := Array( GRA_AA_COUNT )
LOCAL aAreaAttrs2  := Array( GRA_AA_COUNT )
LOCAL aAreaAttrs3  := Array( GRA_AA_COUNT )
LOCAL aStringAttrs := Array( GRA_AS_COUNT )
LOCAL aLineAttrs   := Array( GRA_AL_COUNT )
LOCAL oFont
LOCAL nHeight      := mp2[4][4] - mp2[4][2]
LOCAL nWidth       := mp2[4][3] - mp2[4][1]
LOCAL nOutline, nRadius, nGradientStepFactor := 1
LOCAL aStartPos    := {mp2[4][1],mp2[4][2]}
LOCAL aEndPos      := {mp2[4][3],mp2[4][4]}
LOCAL i, j, cCaption, nAlign, nStartRow, nStartCol, nEndRow, nEndCol, ;
      nFGColor, aSource, aTarget, nAspect, lDisabled, aColor, cFont, ;
      oBitmap, aSize, aColors, nBGColor, nStart, nEnd, nStep, ;
      lSelected, nTextHeight, nTotalHeight, nStartRowSave, oTileBitmap, ;
      nGradientStep, aColorSave, oOldFont, aStartPosG, aEndPosG, ;
      bCaption, lFocus := .f., aLineStartPos, aLineEndPos, aChildren, ;
      nColor

IF ::status() <= 0 .OR. ::outline == NIL .OR. !::isVisible()
  RETURN nil
ENDIF

lSelected := .f.
lDisabled := .f.
IF ::activated
  ::mouseMode := 1
ENDIF

IF Valtype(::color) == 'B'
  aColor := Eval(::color,self)
  ::fgColor := aColor[1]
  ::bgColor := aColor[2]
ENDIF

IF ::mouseMode == 1 .AND. !Empty(::mouseOverSound)
  PlayWave(::mouseOverSound)
ENDIF

IF ::selected .AND. ::mouseMode # 1
   aAreaAttrs2[GRA_AA_COLOR] := ::bgColorSelected
   nBGColor := ::bgColorSelected
ELSEIF BAND(mp2[3],XBP_DRAWSTATE_SELECTED) != 0
   IF ::isStatic
     RETURN nil
   ENDIF
   lSelected := .t.
   aAreaAttrs2[GRA_AA_COLOR] := ::bgColorClick
   nBGColor := ::bgColorClick
ELSEIF BAND(mp2[3],XBP_DRAWSTATE_DISABLED) != 0
   aAreaAttrs2[GRA_AA_COLOR] := ::disabledBGColor
   lDisabled := .t.
ELSE
   aAreaAttrs2[GRA_AA_COLOR] := IIF(::mouseMode==1,::bgColorMouse,::bgColor)
   nBGColor := IIF(::mouseMode==1,::bgColorMouse,::bgColor )
ENDIF

IF lDisabled
  nBGColor := ::disabledBGColor
ENDIF

nRadius := ::radius
DEFAULT nRadius := 0
nOutline := IIF( ::outline .OR. ::mouseMode==1, GRA_OUTLINEFILL, GRA_FILL )

IF nRadius > 0 .AND. !::isBitmapBackground
  nColor := ::setParent():setColorBG()
  IF Empty(nColor)
    IF IsMethod(::setParent():setParent(),'SETCOLORBG')
      nColor := ::setParent():setParent():setColorBG()
    ENDIF
  ENDIF
  aAreaAttrs3[GRA_AA_COLOR] := nColor
  GraSetAttrArea( oPS, aAreaAttrs3 )
  GraBox( oPS, aStartPos, aEndPos, GRA_FILL )
ENDIF

// abo service paint the shadow first.
  // startpos ( pixels van links, pixels omhoog )  endpos ( pixels van links, hoogte) dus het is COL, ROW

IF ::shadowType == 9                      // big shadow for bigger buttons

   aAreaAttrs3[GRA_AA_COLOR] := GraMakeRGBColor( { 240, 240, 240 } )
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+4,aStartpos[2] } ,{ aEndpos[1], aEndpos[2]-4 }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := GraMakeRGBColor( { 200, 200, 200 } )
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+5,aStartpos[2]+1 } ,{ aEndpos[1]-1, aEndpos[2]-5 }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := GraMakeRGBColor( { 160, 160, 160 } )
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+6,aStartpos[2]+2 } ,{ aEndpos[1]-2, aEndpos[2]-6 }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := GraMakeRGBColor( { 160, 160, 160 } )
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+7,aStartpos[2]+3 } ,{ aEndpos[1]-3, aEndpos[2]-7 }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := GraMakeRGBColor( { 120, 120, 120 } )
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+8,aStartpos[2]+4 } ,{ aEndpos[1]-4, aEndpos[2]-8 }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_BLACK
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+7,aStartpos[2]+5 } ,{ aEndpos[1]-5, aEndpos[2]-7 }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_WHITE
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1],aStartpos[2]+7 } ,{ aEndpos[1]-6, aEndpos[2]-8 }, GRA_FILL, nRadius, nRadius )

   aStartpos[1]+=1
   aStartpos[2]+=6
   aEndPos[1]-=6
   aEndPos[2]-=0

ELSEIF ::shadowType == 8                      // dark gray shadow, with WHITE border

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_DARKGRAY
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, aStartpos, aEndpos, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_WHITE // GraMakeRGBColor( {228,229,229})
   GraSetAttrArea( oPS, aAreaAttrs3 )
   aStartpos[2]+=1
   aEndPos[1]-=1
   GraBox( oPS, aStartpos, aEndpos, GRA_FILL, nRadius, nRadius )
   aStartpos[2]+=1
   aEndPos[1]-=1

ELSEIF ::shadowType == 7

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_DARKGRAY
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+2,aStartpos[2] } ,{ aEndpos[1], aEndpos[2] }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_BLACK
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+3,aStartpos[2]+1 } ,{ aEndpos[1]-1, aEndpos[2]-1 }, GRA_FILL, nRadius, nRadius )

   aStartpos[1]+=0
   aStartpos[2]+=2
   aEndPos[1]-=2
   aEndPos[2]-=0

ELSEIF ::shadowType == 6

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_PALEGRAY
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+2,aStartpos[2] } ,{ aEndpos[1], aEndpos[2] }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_DARKGRAY
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+3,aStartpos[2]+1 } ,{ aEndpos[1]-1, aEndpos[2]-1 }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_BLACK
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+4,aStartpos[2]+2 } ,{ aEndpos[1]-2, aEndpos[2]-2 }, GRA_FILL, nRadius, nRadius )

   aStartpos[1]+=0
   aStartpos[2]+=3
   aEndPos[1]-=3
   aEndPos[2]-=0

ELSEIF ::shadowType == 5

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_PALEGRAY
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+2,aStartpos[2] } ,{ aEndpos[1], aEndpos[2] }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_DARKGRAY
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+3,aStartpos[2]+1 } ,{ aEndpos[1]-1, aEndpos[2]-1 }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_WHITE
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1],aStartpos[2]+2 } ,{ aEndpos[1]-2, aEndpos[2]-2 }, GRA_FILL, nRadius, nRadius )

   aStartpos[1]+=0
   aStartpos[2]+=3
   aEndPos[1]-=3
   aEndPos[2]-=0

ELSEIF ::shadowType == 4

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_PALEGRAY
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+2,aStartpos[2] } ,{ aEndpos[1], aEndpos[2] }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_DARKGRAY
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+3,aStartpos[2]+1 } ,{ aEndpos[1]-1, aEndpos[2]-1 }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_WHITE
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1],aStartpos[2]+2 } ,{ aEndpos[1]-2, aEndpos[2]-2 }, GRA_FILL, nRadius, nRadius )

   aStartpos[1]+=1
   aStartpos[2]+=3
   aEndPos[1]-=3
   aEndPos[2]-=0

ELSEIF ::shadowType == 3

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_PALEGRAY
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+2,aStartpos[2] } ,{ aEndpos[1], aEndpos[2] }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_DARKGRAY
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+3,aStartpos[2]+1 } ,{ aEndpos[1]-1, aEndpos[2]-1 }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := ::bordercolor
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1],aStartpos[2]+2 } ,{ aEndpos[1]-2, aEndpos[2]-2 }, GRA_FILL, nRadius, nRadius )

   aStartpos[1]+=1
   aStartpos[2]+=3
   aEndPos[1]-=3
   aEndPos[2]-=0

ELSEIF ::shadowType == 2

   aAreaAttrs3[GRA_AA_COLOR] := GraMakeRGBColor( { 220, 220, 220 } )
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+1,aStartpos[2] } ,{ aEndpos[1], aEndpos[2] }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_PALEGRAY
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+2,aStartpos[2]+1 } ,{ aEndpos[1]-1, aEndpos[2]-1 }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_DARKGRAY
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+3,aStartpos[2]+2 } ,{ aEndpos[1]-2, aEndpos[2]-2 }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_BLACK
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+4,aStartpos[2]+3 } ,{ aEndpos[1]-3, aEndpos[2]-3 }, GRA_FILL, nRadius, nRadius )

   aStartpos[1]+=0
   aStartpos[2]+=4
   aEndPos[1]-=4
   aEndPos[2]-=0

ELSEIF ::shadowType == 1

   aAreaAttrs3[GRA_AA_COLOR] := GraMakeRGBColor( { 220, 220, 220 } )
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+1,aStartpos[2] } ,{ aEndpos[1], aEndpos[2] }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_PALEGRAY
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+2,aStartpos[2]+1 } ,{ aEndpos[1]-1, aEndpos[2]-1 }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_DARKGRAY
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+3,aStartpos[2]+2 } ,{ aEndpos[1]-2, aEndpos[2]-2 }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_BLACK
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1]+4,aStartpos[2]+3 } ,{ aEndpos[1]-3, aEndpos[2]-3 }, GRA_FILL, nRadius, nRadius )

   aAreaAttrs3[GRA_AA_COLOR] := COLOR_WHITE
   GraSetAttrArea( oPS, aAreaAttrs3 )
   GraBox( oPS, { aStartpos[1],aStartpos[2]+4 } ,{ aEndpos[1]-6, aEndpos[2]-4 }, GRA_FILL, nRadius, nRadius )

   aStartpos[1]+=1
   aStartpos[2]+=4
   aEndPos[1]-=4
   aEndPos[2]-=0

ENDIF

IF Valtype(::shadowType) == 'N' .AND. ::shadowType > 0
  aAreaAttrs3[GRA_AA_COLOR] := COLOR_BLACK
  GraSetAttrArea( oPS, aAreaAttrs3 )
  GraBox( oPS, { aStartpos[1]+4,aStartpos[2]+3 } ,{ aEndpos[1]-3, aEndpos[2]-3 }, GRA_FILL, nRadius, nRadius )
ENDIF

IF ::bgColor == GRA_CLR_BACKGROUND
   nOutline := GRA_FILL
ENDIF


IF (::isPopUp .OR. ::outline) .AND. !lFocus                                       // ABO service 22/08
  aLineAttrs[GRA_AL_WIDTH] := GRA_LINEWIDTH_NORMAL
  aLineAttrs[GRA_AL_COLOR] := ::borderColor
  GraSetAttrLine( oPS, aLineAttrs )
  nOutline := GRA_OUTLINEFILL
ENDIF

GraSetAttrArea( oPS, aAreaAttrs2 )
GraBox( oPS, aStartPos, aEndPos, nOutLine, nRadius, nRadius )

IF Valtype(::gradientBlock) == 'B'

  Eval(::gradientBlock,self,oPS,mp2,nMode)

ELSE

  IF Empty(::gradientStep)
    ::gradientStep := 0
  ENDIF

  IF ::gradientStep > 0  .AND. ((::isTransparent # nil .AND. !::isTransparent) .OR. ::mouseMode == 1) // .AND. nRadius == 0

    aColors := DC_GraGetRGBIntensity( nBgColor )
    IF aColors == NIL
      aColors := { 255, 255, 255 }
    ENDIF
    IF (::mouseMode == 1 .AND. ::gradientReverse) .OR. lSelected .OR. ::selected
      IF ::gradientStyle == 1 // vertical (top to bottom)
        nEnd := nHeight-1
        nStart := 1
        nStep := 1
      ELSEIF ::gradientStyle ==2 // vertical (bottom to top)
        nEnd := 1
        nStart := nHeight-1
        nStep := -1
      ELSEIF ::gradientStyle == 3 // horizontal (left to right)
        nEnd := 1
        nStart := nWidth-1
        nStep := 1
      ELSEIF ::gradientStyle == 4 // horizontal (right to right)
        nEnd := nWidth-1
        nStart := 1
        nStep := -1
      ENDIF
    ELSE
      IF ::gradientStyle == 1 // vertical (top to bottom)
        nStart := nHeight-1
        nEnd := 1
        nStep := -1
      ELSEIF ::gradientStyle == 2 // vertical (bottom to top)
        nStart := 1
        nEnd := nHeight-1
        nStep := 1
      ELSEIF ::gradientStyle == 3 // horizontal (left to right)
        nEnd := nWidth-1
        nStart := 1
        nStep := 1
      ELSEIF ::gradientStyle == 4 // horizontal (right to right)
        nEnd := 1
        nStart := nWidth-1
        nStep := -1
      ENDIF
    ENDIF
    nGradientStep := 0
    aColorSave := AClone(aColors)
    aStartPosG := AClone(aStartPos)
    aEndPosG := AClone(aEndPos)

    IF (::gradientStyle == 5 .OR. ::gradientStyle == 6) .AND. nRadius <=0
      nRadius := 1
    ENDIF

    IF nRadius > 0
      nStart := 1
      //nEnd := 1000
      nEnd := (aEndPos[2]-aStartPos[2])*(::gradientlevel/100)          // abo service  (was 1000) Now height / level in %
      nStep := 1
      aLineAttrs[GRA_AL_WIDTH] := GRA_LINEWIDTH_THICK
      GraSetAttrLine( oPS, aLineAttrs )
      aStartPosG[1]+=2
      aStartPosG[2]+=2
      aEndPosG[1]-=2
      aEndPosG[2]-=2
    ELSEIF Empty(nStep)
      nStep := 1
    ENDIF

	if ::gradientStyle == 9						// Office 2007 look - Chris Andries
		aLineAttrs[GRA_AL_WIDTH] := 1
		GraSetAttrLine( oPS, aLineAttrs )

		//if nRadius < 1
		//	nRadius := 5
		//endif
		if nHeight > 55
			nGradientStepFactor := 0.5
		// elseif nHeight < 45
		//	::gradientStep := ::gradientStep*3
		elseif nHeight < 25
			nGradientStepFactor := 2
		endif
		nStart := int(nHeight/3)*2
        nEnd := nHeight-aEndPos[2]+2
        nStep := -1
		FOR i := nStart TO nEnd STEP nStep
			aColors[1] := aColorSave[1]+Int(nGradientStep)
			aColors[2] := aColorSave[2]+Int(nGradientStep)
			aColors[3] := aColorSave[3]+Int(nGradientStep)
			GraSetColor( oPS, GraMakeRGBColor(aColors) )
			GraLine( oPS, { aStartpos[1]+1, i }, { aEndPos[1]-2, i })
			nGradientStep += ::gradientStep*nGradientStepFactor
		NEXT

		nGradientStep -= ::gradientStep*2*nGradientStepFactor
		nStart := int(nHeight/3)*2
        nEnd := nHeight-aStartpos[2]-2
        nStep := 1
		if nRadius > 0
			GraLine( oPS, { aStartpos[1]+2,nHeight-aStartpos[2]-1 }, { aEndPos[1]-2, nHeight-aStartpos[2]-1 })   // bovenste lijn
		endif
		FOR i := nStart TO nEnd STEP nStep
			aColors[1] := aColorSave[1]+Int(nGradientStep)
			aColors[2] := aColorSave[2]+Int(nGradientStep)
			aColors[3] := aColorSave[3]+Int(nGradientStep)
			GraSetColor( oPS, GraMakeRGBColor(aColors) )
			GraLine( oPS, { aStartpos[1]+1, i }, { aEndPos[1]-2, i })
			nGradientStep += ::gradientStep*nGradientStepFactor
		NEXT
		if nRadius > 0
			GraLine( oPS, { aEndpos[1]-1, aStartpos[2]+2 }, { aEndPos[1]-1,aEndPos[2]-3 })	   // rechts
			nGradientStep += ::gradientStep*nGradientStepFactor
			aColors[1] := aColorSave[1]+Int(nGradientStep)
			aColors[2] := aColorSave[2]+Int(nGradientStep)
			aColors[3] := aColorSave[3]+Int(nGradientStep)
			GraSetColor( oPS, GraMakeRGBColor(aColors) )
			GraLine( oPS, { aStartpos[1]+2,nHeight-aEndPos[2]+1 }, { aEndPos[1]-3, nHeight-aEndPos[2]+1 })   // onderste lijn
			nGradientStep += ::gradientStep*nGradientStepFactor
			aColors[1] := aColorSave[1]+Int(nGradientStep)
			aColors[2] := aColorSave[2]+Int(nGradientStep)
			aColors[3] := aColorSave[3]+Int(nGradientStep)
			GraSetColor( oPS, GraMakeRGBColor(aColors) )
			GraLine( oPS, { aStartpos[1]+1, aStartpos[2]+3 }, { aStartpos[1]+1,aEndPos[2]-3})   // links
		endif
	else		// other styles
		FOR i := nStart TO nEnd STEP nStep
		  aColors[1] := aColorSave[1]-Int(nGradientStep)
		  aColors[2] := aColorSave[2]-Int(nGradientStep)
		  aColors[3] := aColorSave[3]-Int(nGradientStep)
		  GraSetColor( oPS, GraMakeRGBColor(aColors) )
		  IF nRadius == 0
			IF ::gradientStyle == 1 .OR. ::gradientStyle == 2
			  GraLine( oPS, { 1, i }, { nWidth-1, i })
			ELSEIF ::gradientStyle == 3 .OR. ::gradientStyle == 4
			  GraLine( oPS, { i, 1 }, { i, nHeight-1 })
			ENDIF
			nGradientStep += ::gradientStep
		  ELSE
			GraBox( oPS, aStartPosG, aEndPosG, GRA_OUTLINE, nRadius, nRadius )
			aStartPosG[1]++
			aStartPosG[2]++
			aEndPosG[1]--
			aEndPosG[2]--
			IF ::gradientReverse .AND. ::mouseMode == 1
			  IF ::gradientStyle == 5 // concentric (inner to outer)
				nGradientStep += ::gradientStep
			  ELSE
				nGradientStep -= ::gradientStep
			  ENDIF
			ELSE
			  IF ::gradientStyle == 6 // concentric (outer to inner)
				nGradientStep += ::gradientStep
			  ELSE
				nGradientStep -= ::gradientStep
			  ENDIF
			ENDIF
			IF aStartPosG[1] >= aEndPosG[1]  .OR. aStartPosG[1] >= aEndPosG[2]
			  EXIT
			ENDIF
		  ENDIF
		NEXT
		IF ::gradientlevel < 100    // abo service if level<100%, fill it up with last color.
			aColors[1] := aColorSave[1]-Int(nGradientStep)+2
			aColors[2] := aColorSave[2]-Int(nGradientStep)+2
			aColors[3] := aColorSave[3]-Int(nGradientStep)+2
			GraSetColor( oPS, GraMakeRGBColor(aColors) )
			GraBox( oPS, {aStartPosG[1]-1,aStartPosG[2]-1} , { aEndPosG[1]+1,aEndPosG[2]+1 } , GRA_FILL, nRadius, nRadius )
			aColors[1] := aColorSave[1]-Int(nGradientStep)
			aColors[2] := aColorSave[2]-Int(nGradientStep)
			aColors[3] := aColorSave[3]-Int(nGradientStep)

			GraSetColor( oPS, GraMakeRGBColor(aColors) )
			GraBox( oPS, aStartPosG, aEndPosG, GRA_FILL, nRadius, nRadius )
		ENDIF                            // abo service end
	endif


  ENDIF

ENDIF

IF !Empty(::tileBitMap)
  IF Valtype(::tileBitmap) == 'B'
    oTileBitMap := DC_GetBitmap(Eval(::tileBitmap,self),,,,,.t.)
  ELSE
    oTileBitmap := ::tileBitmap
  ENDIF
  IF Valtype(oTileBitmap) == 'O'
    aSource := {0,0,oTileBitMap:xSize,oTileBitmap:ySize}
    aTarget := AClone(aSource)
    FOR i := 0 TO nHeight STEP oTileBitMap:ySize
      FOR j := 0 TO nWidth STEP oTileBitMap:xSize
        oTileBitMap:draw( oPS, aTarget, aSource, GRA_BLT_BBO_IGNORE )
        aTarget[1] += oTileBitMap:xSize
        aTarget[3] += oTileBitMap:xSize
      NEXT
      aTarget[1] := 0
      aTarget[3] := oTileBitMap:xSize
      aTarget[2] += oTileBitMap:ySize
      aTarget[4] += oTileBitMap:ySize
    NEXT
  ENDIF
ENDIF

IF !Empty(::menuBlock)
  IF Empty(::menuButtonFont)
    ::menuButtonFont := XbpFont():new()
    ::menuButtonFont:nominalPointSize := 8
    ::menuButtonFont:compoundName := 'Marlett'
    ::menuButtonFont:create()
  ENDIF
  GraSetColor( oPS, GRA_CLR_BLACK ) // Black
  aLineAttrs[GRA_AL_WIDTH] := GRA_LINEWIDTH_NORMAL
  GraSetAttrLine( oPS, aLineAttrs )
  GraLine( oPS, { nWidth - ::menuButtonWidth, aStartPos[2] }, { nWidth - ::menuButtonWidth, nHeight } )
  IF Valtype(::menuButtonFont) == 'O'
    GraSetColor( oPS, GRA_CLR_BLACK ) // Black
    oFont := GraSetFont( oPS, ::menuButtonFont )
    GraCaptionStr( oPS, { nWidth-::menuButtonWidth+(::menuButtonWidth/2)-5, nHeight/2-5 },, 'u' )
    GraSetFont( oPS, oFont )
  ENDIF
ENDIF

IF BAND(mp2[3],XBP_DRAWSTATE_DISABLED) != 0
   aStringAttrs[GRA_AS_COLOR] := ::disabledBGColor
ELSEIF BAND(mp2[3],XBP_DRAWSTATE_SELECTED) != 0
   aStringAttrs[GRA_AS_COLOR] := XBPSYSCLR_WINDOW
ENDIF
aStringAttrs[GRA_AS_VERTALIGN] := GRA_VALIGN_HALF

FOR i := 1 TO Len(::captionArray)

  bCaption   := ::captionArray[i,1]
  nFGColor   := IIF(Valtype(::color)=='B',::fgColor,::captionArray[i,2])
  nStartRow  := ::captionArray[i,3]
  nStartCol  := ::captionArray[i,4]
  nEndRow    := ::captionArray[i,5]
  nEndCol    := ::captionArray[i,6]
  nAlign     := ::captionArray[i,7]
  cFont      := ::captionArray[i,8]
  cCaption   := ::captionArray[i,9]
  oFont      := ::captionArray[i,10]

  IF lDisabled
    nFGColor := ::disabledFGColor      // abo service
  ELSEIF ::selected
    nFGColor := ::fgColorSelected
  ELSEIF lSelected
    nFGColor := ::fgColorClick
  ELSEIF ::mouseMode == 1
    nFGColor := ::fgColorMouse
  ELSEIF Valtype(nFGColor) = 'B'
    nFGColor := Eval(nFGColor,self)
  ENDIF

  IF Valtype(nFGColor) == 'A'
    nFGColor := GraMakeRGBColor(nFGColor)
  ENDIF

  IF ::mouseMode == 1 .AND. !Empty(::mouseOverFont) .AND. !::setNormalFont
    oFont := ::mouseOverFont
  ENDIF

  IF nStartRow == nil
    nStartRow := aStartPos[2]
  ENDIF

  IF nStartCol == nil
    nStartCol := aStartPos[1]
  ENDIF

  IF nEndRow == nil
    nEndRow := aEndPos[2]
    nEndCol := aEndPos[1] - IIF( !Empty(::menuBlock),::menuButtonWidth,0 )
  ENDIF

  aSize := { nEndCol-nStartCol, nEndRow-nStartRow }

  IF Valtype(oFont) == 'B'
    oFont := Eval(oFont,self)
    IF Valtype(oFont) == 'C'
      oFont := DC_FontConfigure( nil, oFont,, oPS, ::getList:scaleFactor )
    ENDIF
  ELSEIF Valtype(oFont) == 'C'
    oFont := DC_FontConfigure( nil, oFont,, oPS, ::getList:scaleFactor )
  ENDIF

  IF Valtype(oFont) == 'O'
    oOldFont := GraSetFont( oPS, oFont )
  ENDIF

  GraSetAttrString( oPS, aStringAttrs )

  IF Valtype(nFGColor) == 'N'
    GraSetColor( oPS, nFGColor )
  ENDIF

  IF Valtype( cCaption ) == 'B'
    cCaption := Eval(cCaption,self)
    IF Valtype(cCaption) == 'A'
      cCaption[1] := DC_GetBitmap(cCaption[1],,,,,.t.)
      IF Valtype(cCaption[1]) == 'O'
         cCaption := cCaption[1]
         nStartRow := (nHeight-cCaption:ySize)/2
         nEndRow := nStartRow + cCaption:ySize
         nStartCol := (nWidth-cCaption:xSize)/2
         nEndCol := nStartCol + cCaption:xSize
      ENDIF
    ENDIF
  ENDIF

  IF Valtype(cCaption) == 'C' .AND. (';' $ cCaption .OR. Chr(13) $ cCaption)
    cCaption := DC_TokenArray(cCaption,';'+Chr(13))
  ENDIF

  IF nStartRow > nEndRow
    nStartRowSave := nStartRow
    nStartRow := nEndRow
    nEndRow := nStartRowSave
  ENDIF

  IF Valtype( cCaption ) == 'A'

    aSize := GraQueryTextBox( oPS, cCaption[1] )
    nTextHeight := aSize[1,2] - aSize[2,2]
    nTotalHeight := Len(cCaption)*nTextHeight
    nStartRow += ((nEndRow-nStartRow)-nTotalHeight)/2

    FOR j := Len(cCaption) TO 1 STEP -1

      IF ::isTextShadow .AND. Valtype(::textShadowColor) == 'N'
        GraSetColor( oPS, ::textShadowColor )
        GraCaptionStr( oPS, { nStartCol+::textShadowOffset, nStartRow-::textShadowOffset }, ;
                          { nEndCol+::textShadowOffset, nStartRow+nTextHeight-::textShadowOffset }, cCaption[j], nAlign )
        IF Valtype(nFGColor) == 'N'
          GraSetColor( oPS, nFGColor )
        ENDIF
      ENDIF

      GraCaptionStr( oPS, { nStartCol, nStartRow }, ;
                          { nEndCol, nStartRow+nTextHeight}, cCaption[j], nAlign )

      nStartRow += nTextHeight
    NEXT

  ELSEIF Valtype( cCaption ) == 'C'

    IF ::isTextShadow .AND. Valtype(::textShadowColor) == 'N'
      GraSetColor( oPS, ::textShadowColor )
      GraCaptionStr( oPS, { nStartCol+::textShadowOffset, nStartRow-::textShadowOffset }, ;
                        { nEndCol+::textShadowOffset, nEndRow-::textShadowOffset }, cCaption, nAlign )
      IF Valtype(nFGColor) == 'N'
        GraSetColor( oPS, nFGColor )
      ENDIF
    ENDIF

    GraCaptionStr( oPS, { nStartCol, nStartRow }, ;
                        { nEndCol, nEndRow }, cCaption, nAlign )

  ELSEIF Valtype( cCaption ) == 'O' .AND. (cCaption:isDerivedFrom('XbpBitMap') .OR. cCaption:isDerivedFrom('XbpIcon'))

    oBitmap := cCaption
    aSource := {0,0,oBitmap:xSize,oBitmap:ySize}

    aTarget := { nStartCol, nStartRow, nEndCol, nEndRow }

    IF oBitmap:isDerivedFrom('XbpIcon')
      oBitmap:Draw( oPS, aTarget, IIF(lDisabled .AND. ::disabledBmp,XBP_STATE_DISABLED,XBP_STATE_NORMAL) )
    ELSE
      oBitmap:draw( oPS, aTarget, aSource, ;
          IIF(lDisabled .AND. ::disabledBmp,GRA_BLT_ROP_PATCOPY,nil), GRA_BLT_BBO_IGNORE )   // abo service
    ENDIF

  ENDIF

  IF Valtype(oOldFont) = 'O'
    GraSetFont( oPS, oOldFont )
  ENDIF

  nFGColor := ::FGColor
  IF Valtype(nFGColor) == 'B'
    nFGColor := Eval(nFGColor,self)
  ENDIF
  GraSetColor( oPS, nFGColor )

NEXT

IF Empty(::focusRectStyle)
  ::focusRectStyle := 0
ENDIF

IF !::isStatic .AND. ::focusRectStyle > 0 .AND. BAND(mp2[3],XBP_DRAWSTATE_FOCUS) != 0
  IF ::focusRectStyle == 1
    aStartPos[1]+=2
    aStartPos[2]+=2
    aEndPos[1]-=2
    aEndPos[2]-=2
    aLineAttrs[GRA_AL_WIDTH] := 1
    aLineAttrs[GRA_AL_COLOR] := ::focusRectColor
    aLineAttrs[GRA_AL_MIXMODE] := GRA_FGMIX_OVERPAINT
    aLineAttrs[GRA_AL_TYPE] := GRA_LINETYPE_DOT
  ELSEIF ::focusRectStyle == 2
    aLineAttrs[GRA_AL_WIDTH] := 1
    aLineAttrs[GRA_AL_COLOR] := ::focusRectColor
    aLineAttrs[GRA_AL_MIXMODE] := GRA_FGMIX_OVERPAINT
  ELSEIF ::focusRectStyle == 3
    aLineAttrs[GRA_AL_WIDTH] := 2
    aLineAttrs[GRA_AL_COLOR] := ::focusRectColor
    aLineAttrs[GRA_AL_MIXMODE] := GRA_FGMIX_OVERPAINT
    aStartPos[1]+=1
    aEndPos[2]-=1
  ENDIF
  GraSetAttrLine( oPS, aLineAttrs )
  GraBox( oPS, aStartPos, aEndPos, GRA_OUTLINE, nRadius, nRadius )
ENDIF

// ::mouseMode := 0

RETURN ::XbpPushButton:Draw(oPS, mp2)

* ---------------

METHOD DC_XbpPushButtonXP:MouseEnter()

LOCAL aPos

IF !::isStatic .AND. !::isResizing
  IF ::mouseOverScale # 1 .AND. ::mouseMode # 1
    ::saveSize := ::currentSize()
    ::savePos := ::currentPos()
    ::setSize({::currentSize()[1]*::mouseOverScale,::currentSize()[2]*::mouseOverScale})
    ::setPos({::currentPos()[1]-((::currentSize()[1]-::saveSize[1])/2), ;
              ::currentPos()[2]-((::currentSize()[2]-::saveSize[2])/2)})
    ::toFront()
  ENDIF
  ::mouseMode := 1
  ::invalidateRect()
ENDIF

RETURN self

* ---------------

METHOD DC_XbpPushButtonXP:MouseLeave()

IF !::isStatic .AND. !::isResizing
  ::mouseMode := 2
  IF ::mouseOverScale # 1 .AND. !Empty(::saveSize)
    ::setSize(::saveSize)
    ::setPos(::savePos)
  ENDIF
  ::invalidateRect()
ENDIF

RETURN self

* ---------------

METHOD DC_XbpPushButtonXP:lbClick( aPos )

IF !::isStatic
  IF !Empty(::menuBlock) .AND. aPos[1] >= ::currentSize()[1] - ::menuButtonWidth
    ::menuClicked := .t.
  ELSE
    ::menuClicked := .f.
  ENDIF
ENDIF

RETURN self

* ------------------

METHOD DC_XbpPushButtonXP:Refresh()

IF (::isCodeBlockCaption .OR. ::isCodeBlockFont .OR. ::isCodeBlockBitmap )
  IF ::isCodeBlockBitmap
    ::setBitMap()
  ENDIF
  ::refreshCaptionArray()
ENDIF

RETURN nil

* ------------------

METHOD DC_XbpPushButtonXP:WhenHideEval( lEnable, lShow, lProtect, nMode )

IF Valtype(::whenBlock) = 'B' .AND. ::parent:isEnabled()
   lEnable := Eval(::whenBlock,self)
   IF lEnable
     IF !::isEnabled()
       ::enable()
     ENDIF
   ELSE
     IF ::isEnabled()
       ::disable()
     ENDIF
   ENDIF
ENDIF

IF Valtype(::hideBlock) = 'B'
   lShow := !Eval(::hideBlock,self)
   IF lShow
      ::show()
   ELSE
      ::hide()
   ENDIF
ENDIF

IF Valtype(::protectBlock) = 'B'
  lProtect := Eval(::protectBlock,self)
ENDIF

RETURN self

* ------------------

METHOD DC_XbpPushButtonXP:SetShortCut()

IF ( ::nShortCut := ::GetShortCut()) != NIL
  ::oldShortCut := SetAppEvent( ::nShortCut, { | uNil1, uNil2, o| ;
               IIF(::isVisible(),(SetAppFocus(self), ;
                                  PostAppEvent( xbeP_Activate,,, self)),nil)})
ENDIF

RETURN self

* ------------------

METHOD DC_XbpPushButtonXP:destroy()

IF ::nShortCut != NIL
  SetAppEvent( ::nShortCut, ::oldShortCut )
ENDIF
::xbpPushButton:destroy()

RETURN self

* ------------------

METHOD DC_XbpPushButtonXP:GetShortCut()

LOCAL nRet, nPos

IF VALTYPE( ::caption) == "C"
  IF ( nPos := AT( "&", ::caption)) != 0
       nRet := xbeK_ALT_A +       ;
       ASC( UPPER( SUBSTR( ::caption, nPos + 1, 1))) - 65
  ENDIF
ENDIF
RETURN( nRet)

* --------------------

METHOD DC_XbpPushButtonXP:Action( a, b, o )

LOCAL i, oXbp, aChildren

IF ::isStatic
  RETURN self
ENDIF

IF (Empty(::protectBlock) .OR. ;
      (Valtype(::protectBlock)=='B' .AND. !Eval(::protectBlock,self) )) .AND. ::isEnabled()

  IF Valtype(::actionBlock) == 'B' .AND. !::menuClicked
    ::activated := .t.
    ::setNormalFont := .t.
    Eval( ::actionBlock, a, b, self, ::getList:getListArray )
    PostAppEvent(xbeM_Leave,,,self)
    ::MouseLeave()
    ::activated := .f.
    ::setNormalFont := .f.

    aChildren := ::parent:childList()
    FOR i := 1 TO Len(aChildren)
      oXbp := aChildren[i]
      IF oXbp:isDerivedFrom("DC_XbpPushButtonXP") .AND. oXbp:selected
        oXbp:selected := .f.
        oXbp:invalidateRect()
      ENDIF
    NEXT
    ::mouseMode := 2
    IF ::enableSelect
      ::selected := .t.
    ENDIF
  ELSEIF Valtype(::menuBlock) == 'B' .AND. ::menuClicked
    ::activated := .t.
    Eval( ::menuBlock, a, b, self, ::getList:getListArray )
    ::activated := .f.
  ENDIF

ENDIF

RETURN self

* -----------------

METHOD DC_XbpPushButtonXP:SetFontName( cFont )

LOCAL i, oPS

IF Valtype(cFont) == 'C'
  ::font := cFont
  oPS := ::lockPS()
//  ::fontObject := DC_FontConfigure(,cFont,,oPS,::getList:scaleFactor)
  FOR i := 1 TO Len(::captionArray)
    ::captionArray[i,10] := DC_FontConfigure(,cFont,,oPS,::getList:scaleFactor)
  NEXT
  ::unLockPS(oPS)
ENDIF

::invalidateRect()

RETURN self

* -----------------

METHOD DC_XbpPushButtonXP:SetFontNameMouseOver( cFont )

LOCAL oPS

IF Valtype(cFont) == 'C' .AND. !Empty(cFont)
  oPS := ::lockPS()
  ::mouseOverFont := cFont
  ::mouseOverFontObject := DC_FontConfigure( nil, cFont,,oPS, ::getList:scaleFactor )
  ::unlockPS(oPS)
ENDIF

RETURN nil

* -----------------

METHOD DC_XbpPushButtonXP:SetBitMap( oBitMap )

IF !Empty(oBitmap)
  ::bitMapSource := oBitMap
ENDIF
IF !Empty(::bitMapSource)
  ::bitMap := DC_GetBitmap(::bitMapSource,,,,,.t.)
  ::configureCaptionArray(.t.)
ENDIF

RETURN self

* -----------------

METHOD DC_XbpPushButtonXP:SetBitMapTile( oBitMap )

IF !Empty(oBitmap)
  ::tileBitMapSource := oBitMap
ENDIF
IF !Empty(::tileBitmapSource)
  ::tileBitMap := DC_GetBitmap(::tileBitmapSource,,,,,.t.)
  ::invalidateRect()
ENDIF

RETURN self

* -----------------

METHOD DC_XbpPushButtonXP:SetCaptionStr( cCaption )

::caption := cCaption
::configureCaptionArray(.t.)

RETURN self

* -----------------

METHOD DC_XbpPushButtonXP:SetCaption( cCaption )

::caption := cCaption
::configureCaptionArray(.t.)

RETURN self

* -----------------

METHOD DC_XbpPushButtonXP:SetCaptionArray( aCaption )

RETURN self

* -----------------

METHOD DC_XbpPushButtonXP:RefreshCaptionArray()

LOCAL bCaption, cCaption, xNewCaption, i, lInvalidate := .f., bFont, oFont, ;
      oPS

oPS := ::lockPS()

FOR i := 1 TO Len(::captionArray)
  bFont := ::captionArray[i,8]
  oFont := ::captionArray[i,10]
  IF Valtype(bFont) == 'B'
    oFont := Eval(bFont,self)
    ::captionArray[i,10] := oFont
    IF Valtype(::captionArray[i,10]) == 'C'
      ::captionArray[i,10] := DC_FontConfigure( nil, ::captionArray[i,10],,oPS, ::getList:scaleFactor )
    ENDIF
  ENDIF
  bCaption := ::captionArray[i,1]
  cCaption := ::captionArray[i,9]
  IF Valtype(bCaption) == 'B'
    xNewCaption := Eval(bCaption,self)
    IF Valtype(xNewCaption) == Valtype(cCaption) .AND. xNewCaption == cCaption
      LOOP
    ENDIF
    xNewCaption := DC_GetBitMap(xNewCaption,,,,,.t.)
    ::captionArray[i,9] := xNewCaption
  ENDIF
  lInvalidate := .t.
NEXT

::unLockPS(oPS)
IF lInvalidate
  ::invalidateRect()
ENDIF

RETURN self

* -----------------

METHOD DC_XbpPushButtonXP:Resize( aOldSize, aNewSize )

LOCAL nYRatio, nXRatio, i, bResize, lResize, ;
      lScaleFont, nX, nY, aPos, aSize, nCurrentCol, nCurrentRow, ;
      nCurrentWidth, nCurrentHeight

nX := (aNewSize[1]-aOldSize[1])
nY := (aNewSize[2]-aOldSize[2])
IF nX = 0 .AND. nY = 0 // .AND. ::mouseMode # 1
  RETURN nil
ENDIF

::isResizing := .t.

nXRatio := aNewSize[1]/aOldsize[1]
nYRatio := aNewSize[2]/aOldSize[2]
bResize := {|x,y,x1,y1,x2,y2|{x1*x2,y1*y2}}

FOR i := 1 TO Len(::captionArray)
  lResize := ::captionArray[i,11]
  DEFAULT lResize := .t.
  IF lResize .AND. Valtype(::captionArray[i,1]) == 'O'
    nCurrentCol    := ::captionArray[i,11]
    nCurrentRow    := ::captionArray[i,12]
    nCurrentWidth  := ::captionArray[i,13]
    nCurrentHeight := ::captionArray[i,14]
    ::captionArray[i,11] := nCurrentCol * nXRatio
    ::captionArray[i,12] := nCurrentRow * nYRatio
    ::captionArray[i,13] := Round(Max(nCurrentWidth * nXRatio,1),6)
    ::captionArray[i,14] := Round(Max(nCurrentHeight * nYRatio,1),6)
    aPos := Eval( bResize, nX, nY, nCurrentCol, nCurrentRow, nXRatio, nYRatio )
    ::captionArray[i,3] := aPos[2]
    ::captionArray[i,4] := aPos[1]
    aSize := Eval( bReSize, nX, nY, nCurrentWidth, nCurrentHeight, nXRatio, nYRatio )
    ::captionArray[i,5] := ::captionArray[i,3] + aSize[2]
    ::captionArray[i,6] := ::captionArray[i,4] + aSize[1]
  ENDIF
NEXT

::invalidateRect()
::isResizing := .f.

RETURN nil

* -----------------

METHOD DC_XbpPushButtonXP:ConfigureCaptionArray( lInvalidate )

LOCAL i, nStartRow, nEndRow, nStartCol, nEndCol, nHeight, cCaption, oBitmap, ;
      lHide, aColor, nWidth, oFont, oPS, oBitmap1, oBitmap2

DEFAULT lInvalidate := .t.

oPS := ::lockPS()

FOR i := 1 TO Len(::captionArray)

  ASize(::captionArray[i],11)

  IF Valtype(::captionArray[i,1]) == 'B'
    ::captionArray[i,9] := Eval(::captionArray[i,1],self)
    ::isCodeBlockCaption := .t.
  ELSE
    ::captionArray[i,9] := ::captionArray[i,1]
  ENDIF

  IF Valtype(::captionArray[i,8]) == 'B'
    ::captionArray[i,10] := Eval(::captionArray[i,8],self)
    ::isCodeBlockFont := .t.
  ELSE
    ::captionArray[i,10] := ::captionArray[i,8]
  ENDIF

  IF Valtype(::captionArray[i,9]) == 'O' // bitmap
    IF Empty(::captionArray[i,5]) .AND. !Empty(::captionArray[i,3]) // end row
      ::captionArray[i,5] := ::captionArray[i,3] + ::captionArray[i,9]:xSize
    ENDIF
    IF Empty(::captionArray[i,6]) .AND. !Empty(::captionArray[i,4])
      ::captionArray[i,6] := ::captionArray[i,4] + ::captionArray[i,9]:ySize
    ENDIF
  ENDIF

  IF Valtype(::captionArray[i,3]) == 'N'
    ::captionArray[i,3] *= ::getList:scaleFactor[2]
    ::captionArray[i,3] := ::currentSize()[2] - ::captionArray[i,3]
  ENDIF
  IF Valtype(::captionArray[i,5]) == 'N'
    ::captionArray[i,5] *= ::getList:scaleFactor[2]
    ::captionArray[i,5] := ::currentSize()[2] - ::captionArray[i,5]
  ENDIF
  IF !Empty(::captionArray[i,4])
    ::captionArray[i,4] *= ::getList:scaleFactor[3]
  ENDIF
  IF !Empty(::captionArray[i,6])
    ::captionArray[i,6] *= ::getList:scaleFactor[3]
  ENDIF

NEXT

IF !Empty(::caption) .OR. !Empty(::bitmap)

  ASize(::captionArray,0)

  nWidth := ::currentSize()[1]
  nHeight := ::currentSize()[2]

  IF Valtype(::caption) $ 'ANO'
    ::bitmap := ::caption
    ::caption := ''
  ENDIF

  IF Valtype(::bitmap) $ 'NOBA' // bitmap

    IF Valtype(::bitmap) == 'A' // array of 2 bitmaps
      oBitmap1 := DC_GetBitmap(::bitmap[1],,,,,.t.)
      oBitmap2 := DC_GetBitmap(::bitmap[2],,,,,.t.)
      ::bitmap := {||IIF(::isEnabled(),oBitmap1,oBitmap2)}
    ENDIF
    IF Valtype(::bitmap) == 'B'
      oBitmap := DC_GetBitMap(Eval(::bitmap,self),,,,,.t.)
      ::isCodeBlockCaption := .t.
    ELSE
      oBitmap := DC_GetBitMap(::bitmap,,,,,.t.)
    ENDIF

    IF Valtype(oBitmap) # 'O'
      // do nothing
      nEndCol := 0
      nEndRow := 0
      nStartRow := 0
      nStartCol := 0
    ELSEIF oBitmap:ySize > nHeight .AND. ::bitmapScale == 1 // -1
      nStartCol := ::bitmapOffset
      nStartRow := 1
      nEndRow := nHeight-2
      nEndCol := nStartCol + (nEndRow-nStartRow)
    ELSE

      IF BAND(::alignBitmap, XBPALIGN_RIGHT ) != 0
        nEndCol := nWidth - ::bitmapOffset
        nStartCol := nEndCol - (oBitmap:xSize * ::bitmapScale)
      ELSEIF BAND(::alignBitmap, XBPALIGN_HCENTER ) != 0
        nStartCol := (nWidth-(oBitmap:xSize * ::bitmapScale))/2
        nEndCol := nStartCol + (oBitmap:xSize * ::bitmapScale)
      ELSE
        nStartCol := ::bitmapOffset
        nEndCol := nStartCol + (oBitmap:xSize * ::bitmapScale)
      ENDIF

      IF BAND(::alignBitmap, XBPALIGN_BOTTOM ) != 0
        nStartRow := ::bitmapOffset
        nEndRow := nStartRow + (oBitmap:ySize * ::bitmapScale)
      ELSEIF BAND(::alignBitmap, XBPALIGN_VCENTER ) != 0
        nStartRow := (nHeight-(oBitmap:ySize*::bitmapScale))/2
        nEndRow := nStartRow + (oBitmap:ySize * ::bitmapScale)
      ELSE
        nEndRow := nHeight - ::bitmapOffset
        nStartRow := nEndRow - (oBitmap:ySize * ::bitmapScale)
      ENDIF
    ENDIF

    AAdd( ::captionArray, ;
          { ::bitmap, ;      // Caption or Caption Block
            nil, ;           // Color
            nStartRow,;      // Start Row
            nStartCol, ;     // Start Column
            nEndRow, ;       // End Row
            nEndCol, ;       // End Column
            nil, ;           // Alignment
            nil, ;           // Font
            oBitmap, ;       // Caption
            nil, ;           // Font Object
            nStartCol, ;
            nStartRow, ;
            nEndCol-nStartCol, ;
            nEndRow-nStartRow } )

    IF BAND(::alignBitmap, XBPALIGN_RIGHT ) != 0
      nEndCol := nStartCol
      nStartCol := ::captionOffset
    ELSEIF BAND(::alignBitmap, XBPALIGN_HCENTER ) != 0
      nStartCol := 0
      nEndCol := nWidth
    ELSE
      nStartCol := nEndCol - ::menuButtonWidth
      nEndCol := nWidth
    ENDIF

    IF BAND(::alignBitmap, XBPALIGN_BOTTOM ) != 0
      nStartRow := nEndRow
      nEndRow := nHeight // - ::captionOffset
    ELSEIF BAND(::alignBitmap, XBPALIGN_VCENTER ) != 0
      nStartRow := 0
      nEndRow := nHeight
    ELSE
      nEndRow := nStartRow
      nStartRow := ::captionOffset
    ENDIF

  ENDIF

  IF !Empty(::caption)
    IF Valtype(::caption) == 'A'
      oBitmap1 := DC_GetBitmap(::caption[1],,,,,.t.)
      oBitmap2 := DC_GetBitmap(::caption[2],,,,,.t.)
      ::caption := {||IIF(::isEnabled(),oBitmap1,oBitmap2)}
    ENDIF
    IF Valtype(::caption) == 'B'
      cCaption := DC_GetBitmap(Eval(::caption,self),,,,,.t.)
      ::isCodeBlockCaption := .t.
      ::disabledBmp := .f.
    ELSEIF Valtype(::caption) == 'C'
      cCaption := Trim(::caption)
    ELSE
      cCaption := ::caption
    ENDIF

    IF Valtype(::font) == 'B'
      oFont := Eval(::font,self)
      ::isCodeBlockFont := .t.
    ELSE
      oFont := ::font
    ENDIF

    AAdd( ::captionArray, ;
         { ::caption, ;       // Caption or Caption Block
           ::fgColor, ;       // Color
           nStartRow,;        // Start Row
           nStartCol, ;       // Start Column
           nEndRow, ;         // End Row
           nEndCol, ;         // End Column
           ::alignCaption, ;  // Alignment
           ::font, ;          // Font
           cCaption, ;        // Caption String
           oFont, ;           // Font Object
           nil, ;
           nil, ;
           nil, ;
           nil } )

  ENDIF

ENDIF

FOR i := 1 TO Len(::captionArray)

  /*
  IF !Empty(::captionArray[i,4])
    ::captionArray[i,4] *= ::getList:scaleFactor[3]
  ENDIF
  IF !Empty(::captionArray[i,5])
    ::captionArray[i,5] *= ::getList:scaleFactor[2]
  ENDIF
  IF !Empty(::captionArray[i,6])
    ::captionArray[i,6] *= ::getList:scaleFactor[3]
  ENDIF
  */


  IF Valtype(::captionArray[i,10]) == 'C'
    ::captionArray[i,10] := DC_FontConfigure( ::setFont(), ::captionArray[i,10],,oPS,::getList:scaleFactor )
  ELSEIF Valtype(::captionArray[i,8]) == 'C'
    ::captionArray[i,10] := DC_FontConfigure( ::setFont(), ::captionArray[i,8],,oPS,::getList:scaleFactor )
  ENDIF

NEXT

::unLockPS(oPS)

IF lInvalidate
  ::invalidateRect()
ENDIF

RETURN self

#endif

* ==============================================

CLASS DC_XbpPushButton FROM DC_XbpPushButtonSuper, DC_XbaseParts

EXPORTED:
  VAR captionBlock
  VAR actionBlock
  VAR validate
  VAR color
  VAR optionArray
  VAR exitKey
  VAR nShortCut
  VAR horizOffset
  VAR vertOffset
  VAR textHeight
  VAR fancy
  VAR graphics
  VAR enabled
  VAR fancyStatic
  VAR font
  VAR ignoreValid
  VAR captionEnabled
  VAR captionDisabled
  VAR oldShortCut
  VAR captionAlign
  VAR captionResType
  VAR captionResFile
  VAR scaleBitmap


METHOD Init, Create, Action, GetShortCut, SetShortCut, Destroy, Refresh, ;
       WhenHideEval, enable, disable

ENDCLASS

* ------------------

METHOD DC_XbpPushButton:Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

LOCAL xOptions, bBlock, cCaption, aGetList, aGetListItem, aGetOptions

::xbpPushButton:Init( oParent, oOwner, aPos, aSize, aPres, lVisible )

::DC_XbaseParts:init( oGetList,,self )
aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions

xOptions := aGetListItem[xGETLIST_OPTIONS8]
DEFAULT xOptions := {}
ASIZE(xOptions,2)
::captionResType := xOptions[1]
::captionResFile := xOptions[2]

xOptions := aGetListItem[xGETLIST_OPTIONS]

DEFAULT xOptions := {}
ASIZE(xOptions,7)

DEFAULT xOptions[1] := 0,  xOptions[2] := 0, ;
        xOptions[3] := 15, xOptions[4] := .f., ;
        xOptions[5] := .f., xOptions[7] := .f.

IF oParent:isDerivedFrom('DC_XbpToolBar') .AND. oParent:fancy
  xOptions[4] := .t.
ENDIF

::optionArray := xOptions
::horizOffset := xOptions[1]
::vertOffset := xOptions[2]
::textHeight := xOptions[3]
::fancy := xOptions[4]
::graphics := xOptions[5]
::scaleBitmap := xOptions[7]
DEFAULT ::scaleBitmap := .f.
::ignoreValid := DC_XtoC(aGetListItem[xGETLIST_CARGO]) == 'CANCEL'

::font := aGetListItem[cGETLIST_FONT]

cCaption := aGetListItem[cGETLIST_CAPTION]

IF Valtype(cCaption)='B'
  cCaption := Eval(cCaption,self)
  ::captionBlock := aGetListItem[cGETLIST_CAPTION]
ENDIF

IF Valtype(cCaption) = 'A'
  ::captionEnabled := DC_GetBitMap(cCaption[1],,::captionResType,::captionResFile,IIF(::scaleBitmap,aSize,nil),.t.)
  ::captionDisabled := DC_GetBitMap(cCaption[2],,::captionResType,::captionResFile,IIF(::scaleBitmap,aSize,nil),.t.)
  cCaption := cCaption[1]
ELSE
  ::captionEnabled := DC_GetBitMap(cCaption,,::captionResType,::captionResFile,IIF(::scaleBitmap,aSize,nil),.t.)
  ::captionDisabled := ::captionEnabled // DC_GetBitMap(cCaption,,::captionResType,::captionResFile,IIF(::scaleBitmap,aSize,nil))
ENDIF

::captionAlign := aGetListItem[xGETLIST_OPTIONS7]

::caption := ::captionEnabled // DC_GetBitmap(cCaption,,::captionResType,::captionResFile,IIF(::scaleBitmap,aSize,nil))


IF Valtype(::caption) == 'C' .AND. Valtype(::captionAlign) == 'N'
  ::caption := Strtran(::caption,';',Chr(13))
  ::captionEnabled := ::caption
  ::captionDisabled := ::caption
ENDIF

IF Valtype(::captionBlock) # 'B'
  ::captionBlock := ::caption
ENDIF
::clipSiblings := .T.
::actionBlock := DC_GetBlock(aGetListItem[bGETLIST_ACTION])
::activate := {|a,b,o|::Action(a,b,o)}
::keyboard := { |a,b,o|IIF(a=xbeK_ENTER,Eval(o:activate,a,b,o,::getList:getListArray),nil) }
::color := aGetListItem[aGETLIST_COLOR]
::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

IF !Empty(::font)
  IF Valtype(::font) == 'B'
    ::SetFontCompoundName( Eval(::font) )
  ELSEIF Valtype(::font) == 'C'
    ::SetFontCompoundName( Alltrim(::font) )
  ENDIF
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

RETURN self

* ------------------ *

METHOD DC_XbpPushButton:create( oParent, oOwner, aPos, aSize, ;
                               aPresParam, lVisible )

LOCAL cCaption, oBitMap, oStatic, aArray, lHide, nWidth, nHeight, ;
      nStartCol, nStartRow, xOptions, aGetList, aGetListItem, aGetOptions, ;
      nButtonStyle, xResource

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions

DEFAULT oParent := ::setParent()

DC_XbpSetColor( ::color, self, oParent, ;
                aGetListItem[aGETLIST_PRESENTATION], .t., .t. )

::xbpPushButton:create( oParent, oOwner, aPos, aSize, aPresParam, lVisible )

lHide := aGetOptions[lGETOPT_HIDEDIALOG]

::SetShortCut()

IF Valtype(::paint) = 'B'
  ::invalidateRect()
ENDIF

IF (::currentSize()[1] = 0 .OR. ::currentSize()[2] = 0) .AND. Valtype(::caption) = 'N'
  oBitMap := XbpBitMap():new(oParent,,,,.f.):create()
  oBitMap:load(nil,::caption)
  ::setSize({oBitMap:xSize+4,oBitMap:ySize+2})
  oBitMap:destroy()
ENDIF

::DC_XbaseParts:setOrig(self)

:: enabled := .t.
IF Valtype(::whenBlock) = 'B' .AND. !Eval(::whenBlock) .AND. !::fancy
  IF Valtype(aGetListItem[cGETLIST_CAPTION]) # 'A'
    ::disable()
  ENDIF
  ::enabled := .f.
ENDIF

IF ( ::fancy  .AND. DC_FancyButtonMode() == 0 ) .OR. DC_FancyButtonMode() == 2 // fancy button
  nWidth := ::currentSize()[1]
  nHeight := ::currentSize()[2]
  nStartCol := ::currentPos()[1]
  nStartRow := ::currentPos()[2]
  cCaption := ::captionBlock

  IF Valtype(cCaption) = 'B'
    cCaption := Eval(cCaption)
  ENDIF
  IF Valtype(cCaption) = 'A'
    cCaption := cCaption[1]
  ENDIF

  cCaption := DC_GetBitMap(cCaption,,::captionResType,::captionResFile,,.t.)

  IF Valtype(cCaption) = 'N'
    oBitMap := XbpBitMap():new(oParent,,,,.f.):create()
    IF Empty(::captionResType)
      oBitMap:load(nil,cCaption)
    ELSE
      xResource := LoadResource( cCaption, ::captionResFile, ::captionResType )
      oBitMap:setBuffer( xResource )
    ENDIF
    aArray := { oBitMap:xSize, oBitMap:ySize }
    oBitMap:destroy()
  ELSEIF Valtype(cCaption) = 'O'
    aArray := { cCaption:xSize, cCaption:ySize }
  ELSE
    aArray := { nWidth, nHeight }
  ENDIF

  oStatic := XbpStatic():new( oParent, , ;
              { nStartCol+(nWidth-aArray[1])/2, ;
                nStartRow+(nHeight-aArray[2])/2 },  ;
              aArray, ;
              _Pres(aGetListItem[aGETLIST_PRESENTATION]), lVisible )
  //
  // 26-11-2012  J. Duijf
  // Prevent application lock-up if a button contains an icon
  // This hapens with the FANCY option or in Toolbars
  // oStatic:type is set correctly now
  //
  Do Case

     Case ValType(cCaption) = "N"
         oStatic:type := XBPSTATIC_TYPE_BITMAP
     Case ValType(cCaption) = "O" .and. cCaption:isDerivedFrom('XbpIcon')
         oStatic:type := XBPSTATIC_TYPE_ICON
     Case ValType(cCaption) = "O" .and. cCaption:isDerivedFrom('XbpBitmap')
         oStatic:type := XBPSTATIC_TYPE_BITMAP
     Otherwise
         oStatic:type := XBPSTATIC_TYPE_TEXT
         IF ::captionAlign == BS_LEFT
           oStatic:options := XBPSTATIC_TEXT_LEFT + XBPSTATIC_TEXT_VCENTER
         ELSEIF ::captionAlign == BS_MULTILINE + BS_LEFT
           oStatic:options := XBPSTATIC_TEXT_WORDBREAK
         ELSEIF ::captionAlign == BS_MULTILINE + BS_CENTER
           oStatic:options := XBPSTATIC_TEXT_WORDBREAK + XBPSTATIC_TEXT_CENTER + XBPSTATIC_TEXT_VCENTER
         ELSEIF ::captionAlign == BS_MULTILINE + BS_VCENTER
           oStatic:options := XBPSTATIC_TEXT_WORDBREAK + XBPSTATIC_TEXT_CENTER + XBPSTATIC_TEXT_VCENTER
         ELSEIF ::captionAlign == BS_RIGHT
           oStatic:options := XBPSTATIC_TEXT_RIGHT + XBPSTATIC_TEXT_VCENTER
         ELSEIF ::captionAlign == BS_CENTER
           oStatic:options := XBPSTATIC_TEXT_CENTER + XBPSTATIC_TEXT_VCENTER
         ELSEIF ::captionAlign == BS_TOP
           oStatic:options := XBPSTATIC_TEXT_TOP
         ELSEIF ::captionAlign == BS_BOTTOM
           oStatic:options := XBPSTATIC_TEXT_BOTTOM
         ELSEIF ::captionAlign == BS_VCENTER
           oStatic:options := XBPSTATIC_TEXT_VCENTER
         ELSEIF ::captionAlign == BS_RIGHT + BS_VCENTER
           oStatic:options := XBPSTATIC_TEXT_RIGHT + XBPSTATIC_TEXT_VCENTER
         ELSEIF ::captionAlign == BS_LEFT + BS_VCENTER
           oStatic:options := XBPSTATIC_TEXT_LEFT + XBPSTATIC_TEXT_VCENTER
         ELSEIF ::captionAlign == BS_CENTER + BS_VCENTER
           oStatic:options := XBPSTATIC_TEXT_CENTER + XBPSTATIC_TEXT_VCENTER
         ELSEIF ::captionAlign == BS_CENTER + BS_TOP
           oStatic:options := XBPSTATIC_TEXT_CENTER + XBPSTATIC_TEXT_TOP
         ELSEIF ::captionAlign == BS_CENTER + BS_BOTTOM
           oStatic:options := XBPSTATIC_TEXT_CENTER + XBPSTATIC_TEXT_BOTTOM
         ELSEIF ::captionAlign == BS_LEFT + BS_BOTTOM
           oStatic:options := XBPSTATIC_TEXT_LEFT + XBPSTATIC_TEXT_BOTTOM
         ELSEIF ::captionAlign == BS_LEFT + BS_TOP
           oStatic:options := XBPSTATIC_TEXT_LEFT + XBPSTATIC_TEXT_TOP
         ELSE
           oStatic:options :=  XBPSTATIC_TEXT_CENTER + XBPSTATIC_TEXT_VCENTER
         ENDIF
  Endcase

  oStatic:caption := cCaption
  oStatic:tabstop := aGetOptions[lGETOPT_TABSTOP]
  IF Valtype(aGetListItem[lGETLIST_TABSTOP]) = 'L'
    oStatic:tabstop := aGetListItem[lGETLIST_TABSTOP]
  ENDIF
  ::hide()
  oStatic:cargo := self
  oStatic:motion := _FancyMouse(oStatic,self,.t.)
  ::motion := oStatic:motion
  oStatic:setinputfocus := ::motion
  oStatic:create()

  ::getList:addHotKey( aGetListItem[nGETLIST_ACCELKEY], ;
                       ::actionBlock, ;
                       ::whenBlock, ;
                       ::hideBlock, ;
                       nil, oStatic )

  DC_XbpSetColor( aGetListItem[aGETLIST_COLOR], oStatic, oParent, ;
                  aGetListItem[aGETLIST_PRESENTATION], .t., .t. )
  IF !Empty(aGetListItem[cGETLIST_FONT])
    oStatic:SetFontCompoundName( Alltrim(aGetListItem[cGETLIST_FONT]) )
  ENDIF
  IF !lHide
    oStatic:show()
  ENDIF
  ::fancyStatic := oStatic
ENDIF

IF ::graphics
  ::motion := {|a,b,o|o:getList:PaintGraControls(o:GetList,o)}
  ::lbUp   := {|a,b,o|o:getList:PaintGraControls(o:GetList,o)}
  ::lbDown := {|a,b,o|o:getList:PaintGraControls(o:GetList,o)}
ENDIF

xOptions := aGetListItem[xGETLIST_OPTIONS2]
IF Empty(xOptions)
  xOptions := aGetOptions[aGETOPT_BUTTONSOUND]
ENDIF
IF !Empty(xOptions)
  ::lbDown := DC_MergeBlocks(::lbDown,_ButtonSoundBlock(xOptions,1))
  ::lbUp   := DC_MergeBlocks(::lbUp,_ButtonSoundBlock(xOptions,2))
ENDIF

IF Valtype(::captionAlign) == 'N'
  nButtonStyle := GetWindowLonga(::GetHwnd(), GWL_STYLE) + ::captionAlign
  SetWindowLongA(::GetHwnd(), GWL_STYLE, nButtonStyle)
ENDIF

RETURN self

* ------------------

METHOD DC_XbpPushButton:refresh()

LOCAL cCaption

IF Valtype(::captionBlock)='B'

  cCaption := DC_GetBitMap(Eval(::captionBlock),,,,,.t.)
  IF Valtype(cCaption) = 'A'
    cCaption := DC_GetBitMap(cCaption[1],1,,,,.t.)
  ENDIF
  IF Valtype(::caption) = 'O' .AND. Valtype(cCaption) # 'O'
    cCaption := DC_GetBitMap(cCaption,,.t.,,,.t.)
  ENDIF
  IF !(Valtype(::caption) == Valtype(cCaption)) .OR. !(::caption == cCaption)
    IF Valtype(::caption) == 'C' .AND. Valtype(::captionAlign) == 'N'
     cCaption := Strtran(cCaption,';',Chr(13))
    ENDIF
    ::setCaption(cCaption)
  ENDIF
  IF Valtype(::fancyStatic) = 'O'
    ::fancyStatic:setCaption(cCaption)
  ENDIF

ENDIF

IF Valtype(::color) = 'B'
  DC_XbpSetColor( ::color, self, nil, nil, .t., .f. )
ENDIF

IF Valtype(::font) = 'B'
  ::setFontCompoundName(Eval(::font))
ENDIF

RETURN self

* ------------------

METHOD DC_XbpPushButton:enable()

::WhenHideEval(,,,1)

RETURN self

* ------------------

METHOD DC_XbpPushButton:disable()

::WhenHideEval(,,,2)

RETURN self

* ------------------

METHOD DC_XbpPushButton:WhenHideEval( lEnable, lShow, lProtect, nMode )

LOCAL aCaption, aColor, nFGColor, nBGColor

DEFAULT nMode := 0

IF Valtype(::captionBlock) = 'B'
  aCaption := Eval(::captionBlock)
  IF Valtype(aCaption) = 'A'
    ::captionEnabled := DC_GetBitMap(aCaption[1],,,,,.t.)
    IF Valtype(::captionEnabled) = 'B'
      ::captionEnabled := Eval(::captionEnabled)
    ENDIF
    ::captionDisabled := DC_GetBitMap(aCaption[2],,,,,.t.)
    IF Valtype(::captionDisabled) = 'B'
      ::captionDisabled := Eval(::captionDisabled)
    ENDIF
  ELSE
    ::captionEnabled := DC_GetBitMap(aCaption,,,,,.t.)
    ::captionDisabled := ::captionEnabled
  ENDIF
ENDIF

IF Valtype(::captionEnabled) == 'C'
  ::captionEnabled := Strtran(::captionEnabled,';',Chr(13))
ENDIF
IF Valtype(::captionDisabled) == 'C'
  ::captionDisabled := Strtran(::captionDisabled,';',Chr(13))
ENDIF

IF Valtype(::color) == 'A' .AND. Valtype(::color[1]) == 'B' ;
      .AND. Valtype(::fancyStatic) = 'O'

  aColor := Eval(::color[1])
  ASize(aColor,2)
  nFGColor := aColor[1]
  nBGColor := aColor[2]

  IF Valtype(nFGColor) == 'A'
    nFGColor := GraMakeRGBColor(nFGColor)
  ENDIF
  IF Valtype(nBGColor) == 'A'
    nBGColor := GraMakeRGBColor(nBGColor)
  ENDIF
  IF Valtype(nFGColor) == 'N' .AND. ::fancyStatic:setColorFG() # nFGColor
    ::fancyStatic:setColorFG(nFGColor)
  ENDIF
  IF Valtype(nBGColor) == 'N' .AND. ::fancyStatic:setColorBG() # nBGColor
    ::fancyStatic:setColorBG(nBGColor)
  ENDIF
ENDIF

IF Valtype(::whenBlock) = 'B' .OR. nMode > 0

   IF nMode = 1
     lEnable := .t.
   ELSEIF nMode = 2
     lEnable := .f.
   ELSE
     lEnable := Eval(::whenBlock,self)
   ENDIF
   IF lEnable
      ::XbpPushButton:enable()
      IF Valtype(::captionEnabled) $ 'CNO'
         IF Valtype(::fancyStatic) = 'O'
            ::fancyStatic:enable()
            IF Valtype(::fancyStatic:caption) # Valtype(::captionEnabled) .OR. ;
               ::fancyStatic:caption # ::captionEnabled
              ::fancyStatic:setCaption(::captionEnabled)
            ENDIF
         ELSE
            IF Valtype(::caption) # Valtype(::captionEnabled) .OR. ;
               ::caption # ::captionEnabled
               ::setCaption(::captionEnabled)
            ENDIF
         ENDIF
      ENDIF
      ::enabled := .t.
      ::XbpPushButton:enable()
      IF Valtype(::fancyStatic) == 'O'
        ::fancyStatic:enable()
      ENDIF
   ELSEIF !lEnable
      IF Valtype(::captionDisabled) $ 'CNO'
         IF Valtype(::fancyStatic) = 'O'
            IF Valtype(::captionDisabled) = 'C'
               ::fancyStatic:disable()
            ENDIF
            IF Valtype(::fancyStatic:caption) # Valtype(::captionDisabled) .OR. ;
                 ::fancyStatic:caption # ::captionDisabled
               ::fancyStatic:setCaption(::captionDisabled)
            ENDIF
         ELSE
            IF Valtype(::caption) # Valtype(::captionDisabled) .OR. ;
               ::caption # ::captionDisabled
               ::setCaption(::captionDisabled)
            ENDIF
            IF Valtype(::caption) = 'C'
               ::XbpPushButton:disable()
            ENDIF
         ENDIF
      ELSE
         ::XbpPushButton:disable()
         IF Valtype(::fancyStatic) == 'O'
           ::fancyStatic:disable()
         ENDIF
      ENDIF
      ::enabled := .f.
   ENDIF

ENDIF

IF Valtype(::hideBlock) = 'B'
   lShow := !Eval(::hideBlock,self)
   IF lShow
      ::show()
   ELSE
      ::hide()
   ENDIF
ENDIF

IF Valtype(::protectBlock) = 'B'
  lProtect := Eval(::protectBlock,self)
ENDIF

RETURN self

* ------------------

METHOD DC_XbpPushButton:SetShortCut()

IF ( ::nShortCut := ::GetShortCut()) != NIL
  ::oldShortCut := SetAppEvent( ::nShortCut, { | uNil1, uNil2, o| ;
               IIF(::isVisible(),(SetAppFocus(self), ;
                                  PostAppEvent( xbeP_Activate,,, self)),nil)})
ENDIF

RETURN self

* ------------------

METHOD DC_XbpPushButton:destroy()

IF ::nShortCut != NIL
  SetAppEvent( ::nShortCut, ::oldShortCut )
ENDIF
::xbpPushButton:destroy()

RETURN self

* ------------------

METHOD DC_XbpPushButton:GetShortCut()

LOCAL nRet, nPos

IF VALTYPE( ::caption) == "C"
  IF ( nPos := AT( "&", ::caption)) != 0
       nRet := xbeK_ALT_A +       ;
       ASC( UPPER( SUBSTR( ::caption, nPos + 1, 1))) - 65
  ENDIF
ENDIF
RETURN( nRet)

* --------------------

METHOD DC_XbpPushButton:Action( a, b )

BEGIN SEQUENCE

IF Valtype(::actionBlock) == 'B' .AND. ::enabled
  IF !::isEnabled()
    BREAK
  ENDIF
  ::captureMouse(.f.)
  IF Empty(::protectBlock) .OR. ;
      (Valtype(::protectBlock)=='B' .AND. !Eval(::protectBlock) )
    Eval( ::actionBlock, a, b, self, ::getList:getListArray )
  ENDIF
ENDIF
END SEQUENCE

IF !Empty(::fancyStatic)
  ::hide()
  ::fancyStatic:show()
ENDIF

RETURN self

* --------------------

STATIC FUNCTION _FancyMouse( oStatic, oButton, lBlock, a, b, oXbp )

IF lBlock
  RETURN {|a,b,o|_FancyMouse(oStatic,oButton,.f.,a,b,o)}
ENDIF

IF oXbp:isderivedFrom('XbpStatic')
  IF Valtype(oButton:whenBlock) == 'B'
    IF !oButton:isEnabled() .OR. !oButton:enabled
      RETURN nil
    ENDIF
  ENDIF
  oStatic:hide()
  oButton:show()
  oButton:captureMouse(.t.)
ELSEIF a[1] < 0 .OR. a[2] < 0 .OR. a[1] > oXbp:currentSize()[1] .OR. ;
       a[2] > oXbp:currentSize()[2]
  oButton:captureMouse(.f.)
  oButton:hide()
  oStatic:show()
ENDIF

RETURN nil

* ==================================================

CLASS DC_XbpPushButtonStatic FROM DC_XbpPushButtonStaticSuper, DC_XbaseParts

EXPORTED
  VAR activate
  VAR Size
  VAR pos
  VAR lastPos
  VAR button
  VAR Type
  VAR focuscolor
  VAR framecolor
  VAR autosize
  VAR sound
  VAR align
  VAR captionBlock
  VAR captionObject
  VAR actionBlock
  VAR validate
  VAR color
  VAR optionArray
  VAR exitKey
  VAR nShortCut
  VAR horizOffset
  VAR vertOffset
  VAR textHeight
  VAR fancy
  VAR enabled
  VAR parent
  VAR ignoreValid
  VAR isMouseInit
  VAR region
  VAR bitmapUp
  VAR bitmapDown
  VAR bitmapNeutral
  VAR bitmapFlash
  VAR flashDelay
  VAR flashIterations
  VAR fontName
  VAR colorFG
  VAR captionAlign
  VAR buttonBorder

METHOD init, create, focus, activate, disable, enable, Invert, ;
       setFontCompoundName, isenabled, setColorBG, action, ;
       WhenHideEval, refresh, mouseinit, handleEvent, setCaption, ;
       reSize, reset

METHOD XbpDialogHandleEvent IS handleEvent IN DC_XbpPushButtonStaticSuper

HIDDEN
  VAR oIcon
  VAR oStatic
  VAR lFocus
  VAR originalcolor
  VAR IconColor

ENDCLASS

* ------------------------

METHOD DC_XbpPushButtonStatic:init( oParent, oOwner, aPos, aSize, ;
                                    aPresParm, lVisible, oGetList )

LOCAL aGetList, aGetListItem, aGetOptions, xOptions, bBlock, cCaption, ;
      aArray

DEFAULT aSize := {0,0}

::DC_XbaseParts:init(oGetList,,self)
aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions
::parent := oParent

::XbpDialog:init( oParent, oOwner, aPos, aSize, aPresParm, lVisible )
::titlebar := .f.

::tabstop := .f.
::align := 1
::pos := aPos
::isMouseInit := .f.

IF Valtype(aGetListItem[xGETLIST_OPTIONS3]) == 'A'
  aArray := aGetListItem[xGETLIST_OPTIONS3]
  ASize(aArray,4)
  ::bitmapUp := DC_GetBitMap(aArray[1],,,,,.t.)
  ::bitmapDown := DC_GetBitMap(aArray[2],,,,,.t.)
  ::bitmapNeutral := DC_GetBitMap(aArray[3],,,,,.t.)
  ::bitmapFlash := DC_GetBitMap(aArray[4],,,,,.t.)
  IF Empty(::bitmapDown)
    ::bitmapDown := ::bitmapUp
  ENDIF
  IF Empty(::bitmapNeutral)
    ::bitmapNeutral := ::bitmapUp
  ENDIF
  IF Empty(::bitmapFlash)
    ::bitmapFlash := ::bitmapUp
  ENDIF
  ::drawingArea:bitmap := ::bitmapNeutral
ENDIF

IF Valtype(aGetListItem[xGETLIST_OPTIONS6]) == 'A'
  aArray := aGetListItem[xGETLIST_OPTIONS6]
  ASize(aArray,2)
  ::flashIterations := aArray[1]
  ::flashDelay := aArray[2]
  DEFAULT ::flashIterations := 0, ;
          ::flashDelay := 30
ENDIF

::activate := {|| nil }
::lFocus := .f.
::Size := aSize
::drawingArea:Motion := {|aPos,u,oS| ::Focus( aPos ) }
::motion := ::drawingArea:motion

::type := XBPSTATIC_TYPE_TEXT
::Lastpos := {-1,-1}
::enabled := .t.
::button := .f.
IF Valtype(aGetListItem[xGETLIST_OPTIONS4]) == 'A'
  ASize(aGetListItem[xGETLIST_OPTIONS4],3)
  ::focuscolor := _NumColor(aGetListItem[xGETLIST_OPTIONS4,1])
  ::framecolor := _NumColor(aGetListItem[xGETLIST_OPTIONS4,2])
  ::buttonBorder := aGetListItem[xGETLIST_OPTIONS4,3]
  DEFAULT ::buttonBorder := XBPDLG_RAISEDBORDERTHICK_FIXED
ENDIF

::autosize := .f.
::sound := NIL

xOptions := aGetListItem[xGETLIST_OPTIONS]
DEFAULT xOptions := {}
ASIZE(xOptions,5)

DEFAULT xOptions[1] := 0,  xOptions[2] := 0, ;
        xOptions[3] := 15, xOptions[4] := .f.

IF ::isDerivedFrom('DC_XbpToolBar') .AND. ::parent:fancy
  xOptions[4] := .t.
ENDIF

::optionArray := xOptions
::horizOffset := xOptions[1]
::vertOffset := xOptions[2]
::textHeight := xOptions[3]
::fancy := xOptions[4]
::ignoreValid := DC_XtoC(aGetListItem[xGETLIST_CARGO]) == 'CANCEL'
::region := aGetListItem[xGETLIST_OPTIONS5]

IF ::fancy .OR. !Empty(::region)
  ::buttonBorder := XBPDLG_NO_BORDER
  ::border := XBPDLG_NO_BORDER
ELSE
  IF ::buttonBorder == NIL
    ::buttonBorder := XBPDLG_RAISEDBORDERTHICK_FIXED
  ENDIF
  ::border := ::buttonBorder
ENDIF

::captionAlign := aGetListItem[xGETLIST_OPTIONS7]
::clipSiblings := .T.
::whenBlock := DC_GetBlock(aGetListItem[bGETLIST_WHEN])
::hideBlock := DC_GetBlock(aGetListItem[bGETLIST_HIDE])
::captionBlock := aGetListItem[cGETLIST_CAPTION]
::actionBlock := DC_GetBlock(aGetListItem[bGETLIST_ACTION])
::activate := {|a,b,o|::Action(a,b,o)}
::keyboard := { |a,b,o|IIF(a=xbeK_ENTER,Eval(o:activate,a,b,o,::getList:getListArray),nil) }
::color := aGetListItem[aGETLIST_COLOR]
IF Valtype(::color)=='A' .AND. Valtype(::color[1]) == 'B'
  ::color := ::color[1]
ENDIF

IF Valtype(::color) == 'A' .AND. Valtype(::color[2]) == 'N'
  ::drawingArea:colorBG := ::color[2]
ENDIF

::cargo := { ::getListPointer, aGetList, aGetListItem[xGETLIST_CARGO] }

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')
IF Valtype(bBlock) = 'B'
  Eval( bBlock, ::drawingArea )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_REFVAR],'O')
IF Valtype(bBlock) = 'B'
  Eval( bBlock, ::drawingArea )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, self )
ENDIF

Return self

* ----------------------

METHOD DC_XbpPushButtonStatic:Create( oParent, oOwner, aPos, aSize, aPresParm, lVisible )

LOCAL aGetList, aGetListItem, aGetOptions, cCaption, cFont, nPointSize, cFamilyName, ;
      nButtonStyle

DEFAULT aSize := ::size

aGetList := ::getList:getListArray
aGetListItem := ::getList:getListArray[::getListPointer]
aGetOptions := ::getList:getOptions

::Size := iif( aSize <> nil, aSize, ::Size )

DEFAULT aPos := ::pos

::XbpDialog:Create( oParent, oOwner, aPos, aSize, aPresParm, lVisible )

::drawingArea:setSize(::currentSize())

::drawingArea:lBdown := ;
   {| aPos| IF(::sound != NIL,_PlaySound(::sound),NIL),::activate( aPos,.f.)  }

::drawingArea:lBUp := {| aPos| ::activate( aPos,.t.), ::reset(), ;
                               ::drawingArea:invalidateRect() }
::button := .f.

cCaption := ::captionBlock
IF Valtype(cCaption)='B'
  cCaption := Eval(cCaption)
ENDIF
IF Valtype(cCaption) = 'A'
  cCaption := cCaption[1]
ENDIF
cCaption := DC_GetBitmap(cCaption,,,,,.t.)

IF !Empty(cCaption)
  IF Valtype(cCaption) == 'C' // .AND. Valtype(::captionAlign) == 'N'
    cCaption := Strtran(cCaption,';',Chr(13))
  ENDIF
  ::captionObject := ;
      XbpStatic():new(::drawingArea,,{0,0}, ;
                      {::drawingArea:currentSize()[1]-6,::drawingArea:currentSize()[2]-6},,.t.)
  ::captionObject:caption := cCaption

  IF Valtype(::captionObject:caption) $ 'NO'
    ::captionObject:type := XBPSTATIC_TYPE_BITMAP
  ELSEIF Valtype(::captionAlign) == 'N'
    ::captionObject:options := ::captionAlign
  ELSE
    ::captionObject:options := XBPSTATIC_TEXT_VCENTER + ;
                               XBPSTATIC_TEXT_CENTER + ;
                               XBPSTATIC_TEXT_WORDBREAK
    ::captionObject:autoSize := .T.
  ENDIF
  cFont := aGetListItem[cGETLIST_FONT]
  IF !Empty(cFont) .AND. Valtype(cFont) == 'C'
    IF ::GetList:scaleFactor[5]
      nPointSize := Val(Substr(cFont,1,At('.',cFont)-1))
      cFamilyName := Substr(cFont,At('.',cFont)+1)
      nPointSize *= ::GetList:scaleFactor[3]
      cFont := Alltrim(Str(Int(nPointSize))) + '.' + cFamilyName
    ENDIF
    ::captionObject:setFontCompoundName(cFont)
    ::fontName := cFont
  ENDIF
  ::captionObject:create()
  ::colorFG := ::captionObject:setColorFG()
  IF Valtype(::captionObject:caption) == 'O' // bitmap
    ::captionObject:setSize({::captionObject:caption:xSize, ;
                             ::captionObject:caption:ySize})
  ENDIF
  IF !Valtype(::captionAlign) == 'N'
    DC_CenterObject(::captionObject)
    ::captionObject:setPos({::captionObject:currentPos()[1]-2, ;
                            ::captionObject:currentPos()[2]-1})
  ENDIF
ENDIF

IF Valtype(::colorFG) # 'N'
  ::colorFG := GRA_CLR_BLACK
ENDIF

IF Valtype(::region) == 'A'
  DC_SetRegion(self,::region)
ENDIF

DC_XbpSetColor( ::color, ::drawingArea, oParent, ;
                aGetListItem[aGETLIST_PRESENTATION], .t., .t. )

::DC_XbaseParts:setOrig(self)

RETURN self

* --------------------

METHOD DC_XbpPushButtonStatic:handleEvent( nEvent, mp1, mp2 )

IF ::enabled
  RETURN ::XbpDialogHandleEvent( nEvent, mp1, mp2 )
ENDIF

RETURN self

* ----------------------

METHOD DC_XbpPushButtonStatic:reSize(aOldSize,aNewSize)

::Size[1] += ( aNewSize[1] - aOldSize[1] )
::Size[2] += ( aNewSize[2] - aOldSize[2] )

RETURN self

* ----------------------

METHOD DC_XbpPushButtonStatic:setColorBG(nColor)
  IF nColor != NIL
    ::drawingArea:setColorBG(nColor)
    IF Valtype(::oStatic) == 'O'
      ::oStatic:setColorBG(nColor)
    ENDIF
  ENDIF

RETURN ::drawingArea:setColorBG()

* -----------------------

METHOD DC_XbpPushButtonStatic:setCaption(bcCaption)

LOCAL cOldCaption := ::captionObject:caption, aArray, nWidth, nHeight, ;
      aTokens, i

nWidth := 0
nHeight := 0

IF Valtype(bcCaption) == 'B'
  bcCaption := Eval(bcCaption)
ENDIF

IF Valtype(bcCaption) = 'C'
  bcCaption := Strtran(bcCaption,';',Chr(13))
ENDIF

::captionObject:setCaption(bcCaption)

IF Valtype(bcCaption) = 'C' .AND. Valtype(::captionAlign) # 'N'
  aTokens := DC_TokenArray(bcCaption,Chr(13))
  aArray := GraQueryTextBox( ::captionObject:lockPS(), bcCaption )
  nHeight := ((aArray[1,2] - aArray[2,2])*Len(aTokens)) + 2
  FOR i := 1 TO Len(aTokens)
    aArray := GraQueryTextBox( ::captionObject:lockPS(), aTokens[i] )
    nWidth := Max( nWidth, ( aArray[3,1] - aArray[1,1]) + 6 ) // width
  NEXT
  ::captionObject:unlockPS()
  ::captionObject:setSize( {nWidth, nHeight })
ELSEIF Valtype(bcCaption) == 'O' // bitmap
  ::captionObject:setSize({::captionObject:caption:xSize, ;
                           ::captionObject:caption:ySize})
ENDIF
DC_CenterObject(::captionObject)
::captionObject:setPos({::captionObject:currentPos()[1]-2, ;
                        ::captionObject:currentPos()[2]-1})

::captionObject:invalidateRect()

RETURN cOldCaption

* -----------------------

METHOD DC_XbpPushButtonStatic:setFontCompoundName(bcFont)

LOCAL cOldFont := ::fontName

IF Valtype(bcFont) == 'B'
  bcFont := Eval(bcFont)
ENDIF

::captionObject:setFontCompoundName(bcFont)
::fontName := bcFont

RETURN cOldFont

* --------------------

METHOD DC_XbpPushButtonStatic:Action( a, b )

IF Valtype(::actionBlock) == 'B' .AND. ::enabled
  Eval( ::actionBlock, a, b, self, ::getList:getListArray )
ENDIF

RETURN self

* --------------------

METHOD DC_XbpPushButtonStatic:reset()

::drawingArea:CaptureMouse( .f. )

IF ::fancy
  ::drawingArea:lockUpdate(.t.)
  IF Empty(::region)
    ::border := XBPDLG_NO_BORDER
    ::drawingarea:setPos({0,0})
  ENDIF
  IF !Empty(::bitmapNeutral) .AND. !Empty(::bitmapUp)
    ::drawingArea:bitmap := ::bitmapNeutral
  ENDIF
  ::configure()
  ::drawingArea:lockUpdate(.f.)
ENDIF

RETURN nil

* --------------------

METHOD DC_XbpPushButtonStatic:mouseInit()

LOCAL i, aChildren

IF !::isMouseInit
  aChildren := ::drawingArea:childList()
  FOR i := 1 TO Len(aChildren)
    _MouseInit(aChildren[i],::drawingArea)
  NEXT
  ::isMouseInit := .t.
ENDIF

RETURN self

* ------------------------

STATIC FUNCTION _MouseInit( oXbp, oDrawingArea )

LOCAL i, aChildren := oXbp:childList()

oXbp:LbDown := oDrawingArea:LbDown
oXbp:LbUp := oDrawingArea:LbUp
oXbp:motion := oDrawingArea:motion

FOR i := 1 TO Len(aChildren)
  _MouseInit( aChildren[i], oDrawingArea )
NEXT

RETURN nil

* --------------------------

METHOD DC_XbpPushButtonStatic:Focus( aPos )

LOCAL i, aChildList, oXbp, oPS, aAttr[ GRA_AL_COUNT], oXbpMouse

oXbpMouse := _MouseCapturedObject()

IF !(oXbpMouse == NIL) .AND. !(oXbpMouse==::drawingArea)
  oXbpMouse:setParent():Focus({-1,-1})
  _MouseCapturedObject( nil )
  RETURN self
ENDIF

If self <> nil .and. ::Status() <> XBP_STAT_INIT .AND. ::enabled
  ::mouseInit()
  if ! ::lFocus .and. aPos[1] >=0 .and. aPos[2] >=0 .and. aPos[1]<= ::Size[1] .and. aPos[2]<= ::Size[2]  .and. ::enabled
    IF ::fancy
      IF Empty(::region)
        ::border := ::buttonBorder
        ::drawingarea:setPos({-3,-3})
        ::drawingarea:setSize({1000,1000})
      ENDIF
      IF !Empty(::bitmapUp)
        ::drawingArea:bitmap := ::bitmapUp
      ENDIF
      ::configure()
      ::drawingArea:invalidateRect()
    ENDIF
    ::drawingArea:CaptureMouse( .t. )
    _MouseCapturedObject(::drawingArea)
    ::lFocus := .t.
    IF Valtype(::focusColor)=='N'
      ::drawingArea:lockUpdate(.t.)
      aChildList := ::drawingArea:childList()
      FOR i := 1 TO Len(aChildList)
        oXbp := aChildList[i]
        IF oXbp:isDerivedFrom('DC_XbpStatic') .AND. ;
            oXbp:type == XBPSTATIC_TYPE_TEXT ;
            .AND. Valtype(oXbp:setcolorFG()) == 'N'
          oXbp:SetColorFG(::focusColor)
        ELSEIF oXbp:isDerivedFrom('XbpStatic') .AND. ;
            oXbp:type == XBPSTATIC_TYPE_TEXT
          oXbp:SetColorFG(::focuscolor)
        ENDIF
      NEXT
      ::drawingArea:lockUpdate(.f.)
      ::drawingArea:invalidateRect()
    ENDIF
    IF Valtype(::frameColor) == 'N'
      aAttr[ GRA_AL_COLOR ] := ::frameColor
      oPS := ::drawingArea:lockPS()
      GraSetAttrLine( oPS, aAttr )
      GraBox( oPS, IIF(::fancy,{3,3},{0,0}), ;
         {::currentSize()[1]-IIF(::fancy,4,7), ;
          ::currentSize()[2]-IIF(::fancy,4,7)}, GRA_OUTLINE )
      ::drawingArea:unlockPS(oPS)
    ENDIF

  ELSEIF aPos[1] < 0 .OR. aPos[2] < 0 .OR. aPos[1] > ::Size[1] .OR. aPos[2] > ::Size[2]

    If ! ::button .and. ::lFocus
      ::lFocus := .f.
      ::drawingArea:CaptureMouse( .f. )
      IF ::fancy
        IF Empty(::region)
          ::border := XBPDLG_NO_BORDER
          ::drawingarea:setPos({0,0})
          DC_CompleteEvents()
        ENDIF
        IF !Empty(::bitmapNeutral) .AND. !Empty(::bitmapUp)
          ::drawingArea:bitmap := ::bitmapNeutral
        ENDIF
        ::drawingArea:configure()
      ENDIF
      IF Valtype(::focusColor)=='N'
        ::drawingArea:lockUpdate(.t.)
        aChildList := ::drawingArea:childList()
        FOR i := 1 TO Len(aChildList)
          oXbp := aChildList[i]
          IF oXbp:isDerivedFrom('DC_XbpStatic') ;
             .AND. oXbp:type == XBPSTATIC_TYPE_TEXT ;
             .AND. Valtype(oXbp:colorFG) == 'N'
            oXbp:SetColorFG( oXbp:colorFG )
          ELSEIF oXbp:isDerivedFrom('XbpStatic') .AND. ;
              oXbp:type == XBPSTATIC_TYPE_TEXT .AND. ;
              Valtype(::colorFG) == 'N'
            oXbp:SetColorFG(::colorFG)
          ENDIF
        NEXT
        ::drawingArea:lockUpdate(.f.)
        ::drawingArea:invalidateRect()
      ENDIF
      ::configure()
      ::invalidateRect()
      ::enable()
    Endif
    ::drawingArea:invalidateRect()
  ENDIF
Endif

return nil

* ------------------

STATIC FUNCTION _MouseCapturedObject( oXbp )

STATIC soXbp := nil
LOCAL oOldXbp := soXbp

IF Pcount() == 1
  soXbp := oXbp
ENDIF

RETURN oOldXbp

* ------------------

METHOD DC_XbpPushButtonStatic:isenabled()
RETURN ::enabled

* ------------------

METHOD DC_XbpPushButtonStatic:refresh()

LOCAL aGetListItem, cCaption

IF Valtype(::captionBlock)='B' .AND. Valtype(::captionObject) == 'O'

  cCaption := DC_GetBitMap(Eval(::captionBlock),,,,,.t.)
  IF Valtype(cCaption) = 'A'
    cCaption := DC_GetBitMap(cCaption[1],1,,,,.t.)
  ENDIF
  IF Valtype(::captionObject:caption) = 'O' .AND. Valtype(cCaption) # 'O'
    cCaption := DC_GetBitMap(cCaption,,.t.,,,.t.)
  ENDIF
  IF !(Valtype(::captionObject:caption) == Valtype(cCaption)) .OR. ;
     !(::captionObject:caption == cCaption)
    ::captionObject:setCaption(cCaption)
  ENDIF

ENDIF

IF Valtype(::color) == 'B'
  aGetListItem := ::getList:getListArray[::getListPointer]
  DC_XbpSetColor( ::color, self:drawingArea, nil, aGetListItem[aGETLIST_PRESENTATION], .t., .f. )
ENDIF

RETURN self

* -------------------

METHOD DC_XbpPushButtonStatic:Activate( aPos, lUp )

LOCAL i, xSaveBitMap

  IF self <> nil .and. ::Status() <> XBP_STAT_INIT  .and. ::Enabled
    ::drawingArea:lockUpdate(.t.)
    IF lUp
      IF ::lFocus
        IF Empty(::region)
          ::border := ::buttonBorder
        ENDIF
        IF !Empty(::bitmapDown) .AND. !Empty(::bitmapUp)
          ::drawingArea:bitmap := ::bitmapUp
        ENDIF
        ::Configure()
        ::invalidateRect()
        DC_CompleteEvents()
      ENDIF
      ::button := .f.
      IF aPos[1] >=0 .and. aPos[2] >=0 .and. aPos[1]<= ::Size[1] .and. aPos[2]<= ::Size[2]
        ::drawingArea:CaptureMouse( .f. )
        IF !Empty(::flashIterations)
          xSaveBitMap := ::drawingArea:bitmap
          FOR i := 1 TO ::flashIterations
            ::drawingArea:bitmap := ::bitmapFlash
            ::configure()
            ::invalidateRect()
            DC_CompleteEvents()
            Sleep(::flashDelay)
            ::drawingArea:bitmap := xSaveBitMap
            ::configure()
            ::invalidateRect()
            DC_CompleteEvents()
            Sleep(::flashDelay)
          NEXT
        ENDIF
        IF ::lFocus .and. ::enabled //could have been turned off
          ::drawingArea:CaptureMouse( .t. )
        ENDIF
        Eval( ::Activate, , , self )
        ::lFocus := .f.
        ::Focus({0,0})
      ENDIF
    ELSEIF ::lFocus

      ::drawingArea:CaptureMouse(.t.)

      IF Empty(::region)
        IF ::buttonBorder == XBPDLG_RAISEDBORDERTHICK
          ::border := XBPDLG_RECESSEDBORDERTHICK
        ELSEIF ::buttonBorder == XBPDLG_RAISEDBORDERTHIN
          ::border := XBPDLG_RECESSEDBORDERTHIN
        ELSEIF ::buttonBorder == XBPDLG_RAISEDBORDERTHICK_FIXED
          ::border := XBPDLG_RECESSEDBORDERTHICK_FIXED
        ELSEIF ::buttonBorder == XBPDLG_RAISEDBORDERTHIN_FIXED
          ::border := XBPDLG_RECESSEDBORDERTHIN_FIXED
        ENDIF
      ENDIF
      IF !Empty(::bitmapDown)
        ::drawingArea:bitmap := ::bitmapDown
      ENDIF
      ::Configure()
      ::invalidateRect()
      DC_CompleteEvents()
      ::Button := .t.
    ENDIF
    ::drawingArea:lockUpdate(.f.)
  ENDIF

Return nil

* ---------------------

METHOD DC_XbpPushButtonStatic:Disable()

LOCAL i, oXbp, aChildList := ::drawingArea:childList()

IF !::enabled
  RETURN .T.
ENDIF

::drawingArea:lockUpdate(.t.)
FOR i := 1 TO Len(aChildList)
  oXbp := aChildList[i]
  IF oXbp:isDerivedFrom('DC_XbpStatic')
    IF oXbp:type <> XBPSTATIC_TYPE_TEXT
      oXbp:disable()
    ELSE
      oXbp:SetColorFG( GRA_CLR_DARKGRAY )
    ENDIF
  ELSEIF oXbp:isDerivedFrom('XbpStatic') .AND. oXbp:type == XBPSTATIC_TYPE_TEXT
    oXbp:disable()
  ENDIF
NEXT
::enabled := .f.
::button := .f.
::drawingArea:CaptureMouse( .f. )
::drawingArea:lockUpdate(.f.)
::drawingArea:disable()
::drawingArea:setColorBG(GRA_CLR_BACKGROUND)
::invalidateRect()

return  .t.

* ----------------------

METHOD DC_XbpPushButtonStatic:Enable()

  LOCAL aChildren, i, oXbp

  IF ::enabled
    RETURN .T.
  ENDIF

  ::drawingArea:lockUpdate(.t.)
  aChildren := ::drawingArea:childList()
  FOR i := 1 TO Len(aChildren)
    oXbp := aChildren[i]
    IF oXbp:isDerivedFrom('DC_XbpStatic') .AND. oXbp:type == XBPSTATIC_TYPE_TEXT
      IF Valtype(oXbp:colorFG) == 'N'
        oXbp:setColorFG( oXbp:colorFG )
      ELSEIF !Empty(oXbp:setParent():setColorFG())
        oXbp:setColorFG(oXbp:setParent():setColorFG())
      ENDIF
    ENDIF
    oXbp:paint := {|| nil }
    ::invalidateRect()
    oXbp:enable()
  NEXT
  ::enabled := .t.
  ::drawingArea:enable()
  ::drawingArea:lockUpdate(.f.)
  ::drawingArea:invalidateRect()
  IF Valtype(::color) == 'A' .AND. Valtype(::color[2]) == 'N'
    ::drawingArea:setColorBG(::color[2])
  ENDIF

Return  .t.

* ------------------------

METHOD DC_XbpPushButtonStatic:invert(oXbp)

LOCAL oPS
IF oXbp <> nil .AND. oXbp:status() <> XBP_STAT_INIT
  oPS := oXbp:LockPS()
  GraBitBlt( oPS, oPS,{0,0,31,31},{0,0,31,31}, GRA_BLT_ROP_DSTINVERT  )
  oXbp:unlockPS( oPS )
ENDIF

RETURN nil

* --------------------

METHOD DC_XbpPushButtonStatic:WhenHideEval( lEnable, lShow )

LOCAL aCaption := ::captionBlock, oCaption, xCaption1, xCaption2

IF Valtype(::whenBlock) = 'B'
  lEnable:= Eval(::whenBlock,self)
  IF lEnable
    ::enable()
    ::enabled := .t.    // enable the pushbutton
  ELSE
    ::disable()
    ::enabled := .f.    // disable the pushbutton
  ENDIF
ENDIF

IF Valtype(::hideBlock) = 'B'
  lShow := !Eval(::hideBlock,self)
  IF lShow
    IF !::isVisible()
      ::show()
      ::invalidateRect()
    ENDIF
  ELSEIF ::isVisible()
    ::hide()
  ENDIF
ENDIF

RETURN self

* --------------------------

PROCEDURE _PlaySound(cFileName)
    _StopSound()
    _PlayWaveFile(cFileName)
RETURN

PROCEDURE _StopSound()
  DllCall("WINMM.DLL",DLL_STDCALL,"PlaySoundA",0,0,0)
  DllCall("WINMM.DLL",DLL_STDCALL,"PlaySoundA",0,0,SND_PURGE)
RETURN

PROCEDURE _PlayWaveFile(cFileName)
  DllCall("WINMM.DLL",DLL_STDCALL,"PlaySoundA",cFileName,0,SND_FILENAME+SND_ASYNC)
RETURN

DLLFUNCTION MessageBeep(nMsgType) USING STDCALL FROM "USER32.DLL"

DLLFUNCTION waveOutGetNumDevs() USING STDCALL FROM "WINMM.DLL"

* -------------------------

/*
 * Class for managing database fields which store bitmap data
 */
STATIC CLASS BitmapRef FROM XbpStatic, DataRef
   PROTECTED:
   VAR oBmp
   VAR oPS
   VAR lIsEmpty

   EXPORTED:
   VAR autoScale
   VAR Scaled
   VAR backcolor
   METHOD init, create, destroy
   METHOD setdata, getdata, editbuffer, draw, loadFile
   METHOD Save
//   METHOD update
ENDCLASS



/*
 * Initialize the object
 */
METHOD BitmapRef:init( oParent, oOwner, aPos, aSize, aPresParem, lVisible )
   ::dataRef:init()
   ::xbpStatic:init( oParent, oOwner, aPos, aSize, aPresParem, lVisible )
   ::autoScale := .T.
   ::lIsEmpty  := .T.
   ::oPS       := XbpPresSpace():new()
   ::oBmp      := XbpBitmap():new()
   ::backcolor := GRA_CLR_BACKGROUND
RETURN self

/*
 * Request system resources and define color for displaying
 * an empty database field
 */
METHOD BitmapRef:create( oParent, oOwner, aPos, aSize, aPresParem, lVisible )
   LOCAL aAttr[ GRA_AA_COUNT ]
   ::xbpStatic:create( oParent, oOwner, aPos, aSize, aPresParem, lVisible )
   ::xbpStatic:setcolorBG(::backcolor)
   ::oPS:create( ::xbpStatic:winDevice() )
   ::oBmp:create( ::oPS )

//   aAttr[ GRA_AA_COLOR ] := GRA_CLR_WHITE
   aAttr[ GRA_AA_COLOR ] := ::backcolor
   ::oPS:setAttrArea( aAttr )
   ::xbpStatic:paint := {||::draw()}
RETURN self

/*
 * Release system resources
 */
METHOD BitmapRef:destroy
   ::oBmp:destroy()
   ::oPS:destroy()
   ::xbpStatic:destroy()
RETURN self

/*
 * Transfer bitmap data from field into buffer
 */
METHOD BitmapRef:setdata( cBuffer )
   IF cBuffer == NIL
      cBuffer := Eval( ::dataLink )
   ENDIF

   IF ! Empty( cBuffer )
      ::oBmp:setBuffer( cBuffer, XBPBMP_FORMAT_WIN3X )
      ::lIsEmpty := .F.
   ELSE
      ::lIsEmpty := .T.
   ENDIF
   ::changed :=  .F.
   ::draw()
RETURN cBuffer

/*
 * Transfer the bitmap buffer into field
 */
METHOD BitmapRef:getdata
   LOCAL cBuffer := ::oBmp:setBuffer()

   IF Valtype( ::dataLink ) == "B" .AND. .NOT. ::lIsEmpty
      Eval( ::dataLink, cBuffer )
   ENDIF
RETURN cBuffer

METHOD BitmapRef:save(cFileName)
  ::scaled := GraSaveScreen(::oPS,{0,0},{150,150})
//  SaveBitmap(::oBmp,cFileName)  //This line saves the normal sized image
  SaveBitmap(::scaled,cFileName)  //This line saves the scaled image
RETURN

METHOD BitmapRef:editbuffer
RETURN ::oBmp:setBuffer()


/*
 * Draw the bitmap and maintain the aspect ratio
 */
METHOD BitmapRef:draw
   LOCAL aSize    := ::currentSize()
   LOCAL aTarget, aSource, nAspect

   GraBox( ::oPS, {1,1}, {aSize[1]-2,aSize[2]-2}, GRA_FILL )

   IF ::lIsEmpty
      RETURN .F.
   ENDIF

   aSource := {0,0,::oBmp:xSize,::oBmp:ySize}
   aTarget := {1,1,aSize[1]-2,aSize[2]-2}

   IF ::autoScale
      nAspect    := aSource[3] / aSource[4]
      IF nAspect > 1
         aTarget[4] := aTarget[3] / nAspect
      ELSE
         aTarget[3] := aTarget[4] * nAspect
      ENDIF
   ELSE
      aTarget[3] := aSource[3]
      aTarget[4] := aSource[4]
   ENDIF

   IF aTarget[3] < aSize[1]-2
      nAspect := ( aSize[1]-2-aTarget[3] ) / 2
      aTarget[1] += nAspect
      aTarget[3] += nAspect
   ENDIF

   IF aTarget[4] < aSize[2]-2
      nAspect := ( aSize[2]-2-aTarget[4] ) / 2
      aTarget[2] += nAspect
      aTarget[4] += nAspect
   ENDIF

RETURN ::oBmp:draw( ::oPS, aTarget, aSource, , GRA_BLT_BBO_IGNORE )

/*
 * Load an external bitmap file
 */
METHOD BitmapRef:loadFile( cBitmap )
   IF ( ::changed := ::oBmp:loadFile( cBitmap ) )
      ::lIsEmpty := .F.
   ENDIF
RETURN ::changed


//-----------------------------------------------------------------------------

FUNCTION SaveBitmap( oXbpBitmap, cFileName )
   LOCAL cBitmap, cHeader, nHandle, nBytes, lOk := .F.

   IF Valtype( oXbpBitMap ) + Valtype( cFileName ) != "OC"
      RETURN .F.                       // Illegal parameters
   ENDIF                               // ** RETURN **

   IF ! "." $ cFileName
      cFileName += ".BMP"
   ENDIF

   nHandle := FCreate( cFileName )
   IF FError() <> 0
      RETURN .F.                       // Error creating file
   ENDIF                               // ** RETURN **

   cBitmap := oXbpBitmap:setBuffer( , XBPBMP_FORMAT_DEFAULT )

   // bitmap info header has 40 bytes
   cBitmap := U2Bin( 40 ) + SubStr( cBitmap, 5 )

   // Create 14 byte bitmap header
   //  1- 2  2 Byte -> "BM"
   //  3- 6  4 Byte -> File size
   //  7- 8  2 Byte -> Chr(0)
   //  9-10  2 Byte -> Chr(0)
   // 11-14  4 Byte -> Offset image data
   cHeader := "BM" + ;
               U2Bin( 14 + Len(cBitmap) ) + ;
               U2Bin( 0 ) + ;
               U2Bin( oXbpBitmap:bufferOffset + 14)

   nBytes  := Len( cHeader ) + Len( cBitmap )
   lOk     := (nBytes == FWrite( nHandle, cHeader + cBitmap, nBytes ))

   FClose( nHandle )

RETURN lOk

//-----------------------------------------------------------------------------

FUNCTION GraSaveScreen( oSourcePS, aPos, aSize )

LOCAL oBitmap   := XbpBitmap():new():create( oSourcePS )
LOCAL oTargetPS := XbpPresSpace():new():create()
LOCAL aSourceRect[4], aTargetRect

aSourceRect[1] := aSourceRect[3] := aPos[1]
aSourceRect[2] := aSourceRect[4] := aPos[2]
aSourceRect[3] += aSize[1]
aSourceRect[4] += aSize[2]
aTargetRect    := {0, 0, aSize[1], aSize[2]}

oBitmap:presSpace( oTargetPS )
oBitmap:make( aSize[1], aSize[2] )

GraBitBlt( oTargetPS, oSourcePS, aTargetRect, aSourceRect )

RETURN oBitmap

// The function GraRestScreen() redisplays a saved
// section of screen. It just uses the :draw() method

FUNCTION GraRestScreen( oTargetPS, aPos, oBitmap )
  oBitmap:draw( oTargetPS, aPos )
RETURN NIL

* ---------------------

FUNCTION _ButtonSoundBlock( abSound, nMode )

IF Valtype(abSound) = 'A'
  abSound := AClone(abSound)
ENDIF

RETURN {||_ButtonSound( abSound, nMode )}

* ---------------------

STATIC FUNCTION _ButtonSound( abSound, nMode )

LOCAL cFileName

IF Valtype(abSound) = 'B'
  abSound := Eval(abSound)
ENDIF

IF Valtype(abSound) # 'A'
  RETURN .f.
ENDIF

ASize( abSound, 2 )
DEFAULT abSound[1] := '', ;
        abSound[2] := ''

IF nMode == 1
  cFileName := abSound[1]
ELSE
  cFileName := abSound[2]
ENDIF

IF Empty(cFileName)
  RETURN ''
ENDIF

DllCall("WINMM.DLL",DLL_STDCALL,"PlaySoundA",0,0,0)
DllCall("WINMM.DLL",DLL_STDCALL,"PlaySoundA",0,0,SND_PURGE)
DllCall("WINMM.DLL",DLL_STDCALL,"PlaySoundA",cFileName,0,SND_FILENAME+SND_ASYNC)

RETURN .t.

* ------------------

STATIC FUNCTION _Pres( aPres )

IF Valtype( aPres ) = 'B'
  RETURN Eval(aPres)
ENDIF

RETURN aPres

* ------------------

STATIC FUNCTION _NumColor( xColor )

IF Valtype(xColor) == 'N'
  RETURN xColor
ELSEIF Valtype(xColor) == 'A'
  RETURN GraMakeRGBColor(xColor)
ENDIF
RETURN xColor

* -------------------

FUNCTION DC_FancyButtonStatic( oButton )

IF IsMemberVar(oButton,'FANCYSTATIC')
  RETURN oButton:fancyStatic
ENDIF
RETURN nil

* --------------------

STATIC PROCEDURE DrawTextBox( aPenPos, cString, oPS )

LOCAL aTextBox, aLeftTop, aLeftBottom, aRightTop, aRightBottom

aTextBox        := GraQueryTextBox( oPS, cString )

aLeftTop        := aTextBox[1]               // relative coordinates for
aLeftBottom     := aTextBox[2]               // the four corner points of the
aRightTop       := aTextBox[3]               // parallelogram
aRightBottom    := aTextBox[4]

aLeftTop[1]     += aPenPos[1]                // convert relative coordinates
aLeftTop[2]     += aPenPos[2]                // to absolute coordinates
aLeftBottom[1]  += aPenPos[1]
aLeftBottom[2]  += aPenPos[2]
aRightTop[1]    += aPenPos[1]

aRightTop[2]    += aPenPos[2]
aRightBottom[1] += aPenPos[1]
aRightBottom[2] += aPenPos[2]
// draw border
GraLine( oPS, aLeftTop, aRightTop )
GraLine( oPS, NIL, aRightBottom )
GraLine( oPS, NIL, aLeftBottom )
GraLine( oPS, NIL, aLeftTop )
// draw character string
GraStringAt( oPS, aPenPos, cString )

RETURN

* ----------------

CLASS DC_XbpPushButtonXPConfig

EXPORTED:

VAR font
VAR focusRectStyle
VAR focusRectColor
VAR radius
VAR outline
VAR color
VAR bgColor
VAR fgColor
VAR fgColorClick
VAR bgColorClick
VAR fgColorSelected
VAR bgColorSelected
VAR alignCaption
VAR alignBitmap
VAR fgColorMouse
VAR bgColorMouse
VAR gradientReverse
VAR gradientStep
VAR gradientStyle
VAR gradientBlock
VAR captionOffset
VAR bitmapOffset
VAR bitmapScale
VAR menuButtonWidth
VAR tileBitMap
VAR mouseOverSound
VAR mouseOverScale
VAR mouseOverFont
VAR disabledBGColor
VAR enableSelect
VAR disabledFGColor
VAR disabledBmp
VAR borderColor
VAR isStatic
VAR cargo
VAR shadowType
VAR gradientLevel
VAR isTransparent
VAR isTextShadow
VAR textShadowColor
VAR textShadowOffset
VAR isBitmapBackground

METHOD Init

ENDCLASS

* ---------------

METHOD DC_XbpPushButtonXPConfig:init()

::focusRectStyle := 1
::focusRectColor := GRA_CLR_BLACK
::radius := 0
::outline := .t.
::bgColor := COLOR_LTYELLOW
::fgColor := COLOR_BLACK
::fgColorClick := COLOR_BLACK
::bgColorClick := COLOR_PINK
::fgColorSelected := COLOR_BLACK
::bgColorSelected := COLOR_GREEN
::alignCaption := XBPALIGN_HCENTER + XBPALIGN_VCENTER
::alignBitmap := XBPALIGN_LEFT + XBPALIGN_VCENTER
::fgColorMouse := COLOR_BLACK
::bgColorMouse := COLOR_CYAN
::gradientReverse := .t.
::gradientStep := 0
::gradientStyle := 1
::captionOffset := 0
::bitmapOffset := 0
::bitmapScale := 1
::menuButtonWidth := 0
::tileBitmap := nil
::mouseOverSound := nil
::mouseOverScale := 1
::mouseOverFont := nil
::disabledBGColor := COLOR_DISABLED
::enableSelect := .f.
::disabledFGColor := COLOR_DISABLEDTEXT
::disabledBmp := .f.
::borderColor := 0
::isStatic := .f.
::shadowType := 0
::gradientLevel := 100
::isTransparent := .f.
::isTextShadow := .f.
::textShadowColor := GRA_CLR_WHITE
::textShadowOffset := 2
::isBitmapBackground := .f.

RETURN self

* --------------

FUNCTION DC_PushButtonStyle( oConfig )

STATIC soConfig
LOCAL oOldConfig := soConfig
IF Valtype(oConfig) == 'O' .AND. oConfig:isDerivedFrom('DC_XbpPushButtonXPConfig')
  soConfig := oConfig
ELSEIF Pcount() == 1 .AND. oConfig == NIL
  soConfig := oConfig
ENDIF

RETURN oOldConfig

* --------------

FUNCTION DC_ExpressButtonStyle( oConfig )

STATIC soConfig
LOCAL oOldConfig := soConfig
IF Valtype(oConfig) == 'O' .AND. oConfig:isDerivedFrom('DC_XbpPushButtonXPConfig')
  soConfig := oConfig
ENDIF

RETURN oOldConfig

* --------------

FUNCTION DC_PopupButtonStyle( oConfig )

STATIC soConfig
LOCAL oOldConfig := soConfig
IF Valtype(oConfig) == 'O' .AND. oConfig:isDerivedFrom('DC_XbpPushButtonXPConfig')
  soConfig := oConfig
ENDIF

RETURN oOldConfig

* --------------

FUNCTION DC_XbpPushButtonXPDefault( oXPDefault )

STATIC soXPDefault
LOCAL oOldXPDefault

oOldXPDefault := soXPDefault

IF Valtype(oXPDefault) == 'O'
  soXPDefault := oXPDefault
ENDIF

IF Empty(oOldXPDefault)
  oOldXPDefault := DC_XbpPushButtonXPConfig():new()
ENDIF


RETURN oOldXPDefault

* --------------

STATIC FUNCTION PlayWave( cWaveFile )

LOCAL x

IF !Empty(cWaveFile)

  x := DllCall("WINMM.DLL",32,"PlaySoundA",cWaveFile,0, ;
                SND_FILENAME + SND_LOOP + SND_NOSTOP + SND_ASYNC )

ELSE // stop current sound

  x := DllCall("WINMM.DLL",32,"PlaySoundA",'__bogus___',0, ;
                SND_FILENAME + SND_ASYNC )

ENDIF

RETURN nil

* ---------------

FUNCTION DC_GraGetRGBIntensity( nColor )

LOCAL aColor

IF nColor > 16
  aColor := GraGetRGBIntensity( nColor )
ELSEIF nColor = GRA_CLR_RED
  aColor := { 255, 0, 0 }
ELSEIF nColor = GRA_CLR_DARKRED
  aColor := { 128, 0, 0 }
ELSEIF nColor = GRA_CLR_GREEN
  aColor := { 0, 255, 0 }
ELSEIF nColor = GRA_CLR_DARKGREEN
  aColor := { 0, 128, 0 }
ELSEIF nColor = GRA_CLR_BLUE
  aColor := { 0, 0, 255 }
ELSEIF nColor = GRA_CLR_DARKBLUE
  aColor := { 0, 0, 128 }
ELSEIF nColor = GRA_CLR_YELLOW
  aColor := { 255, 255, 0 }
ELSEIF nColor = GRA_CLR_BROWN
  aColor := { 128, 128, 0 }
ELSEIF nColor = GRA_CLR_CYAN
  aColor := { 0, 255, 255 }
ELSEIF nColor = GRA_CLR_DARKCYAN
  aColor := { 0, 128, 128 }
ELSEIF nColor = GRA_CLR_PINK
  aColor := { 255, 0, 255 }
ELSEIF nColor = GRA_CLR_DARKPINK
  aColor := { 128, 0, 128 }
ELSEIF nColor = GRA_CLR_BLACK
  aColor := { 0, 0, 0 }
ELSEIF nColor = GRA_CLR_WHITE
  aColor := { 255, 255, 255 }
ELSEIF nColor = GRA_CLR_PALEGRAY
  aColor := { 128, 128, 128 }
ELSE
  aColor := GraGetRGBIntensity( nColor )
ENDIF

RETURN aColor
